/* Copyright (C) 2001  Sony Computer Entertainment Inc.
 *
 * "basic.vcl" 
 * simple transform with vector frame
 * next simplest attempt at VU microcode -- steve 29th May 2003
 */

.include 	"mymacros.m"

; pad masks

kSquare .assign 	H'7FFF	;remember add 1 for 0x8000
kCross .assign 		H'4000
kTriangle .assign 	H'1000
kCircle .assign 	H'2000
kR1 .assign 		H'0800
kR2 .assign 		H'0200
kStart .assign 		H'0008
kLeft .assign 		H'0080
kDown .assign 		H'0040
kUp .assign 		H'0010
kRight .assign 		H'0020

kViewRear .assign	H'0001
kNotViewRear .assign	H'0FFE
kWarp .assign		H'0002
kNotWarp .assign	H'0FFD
kFlagH	 .assign	H'0004
kNotFlagH .assign	H'0FFB

kHistoryStart .assign 12
kHistoryEnd   .assign 112
kSin   .assign 112
kSinSize .assign 12

kLight		 .assign 0.5
kLightTick	 .assign 2.5

;113+24=137
kTicker  .assign 5
kTag0	.assign	138
kTag1	.assign	539

        .init_vf_all    ; allow vcl to use all VF registers
        .init_vi_all    ; allow vcl to use all VI registers
        .syntax new

        .vu
       --enter         ; declare an entry point to the code
                       ; there are no externally set registers..
       --endenter      ; end declaration of entry point

; we do this bit once only for VU demo
 START:
	;xtop iBase
	lq vf01, 0(vi00)
	sq vf01, kTag0(vi00)
	sq vf01, kTag1(vi00)
	;lq depth,1(iBase)
	lq origin, 2(vi00)
	lq window, 3(vi00)
	lq Frame[0], 4(vi00)
	lq Frame[1], 5(vi00)
	lq Frame[2], 6(vi00)
	
;	lq dxdy, 7(vi00)
;	lq colour, 8(iBase)

	lq posangles, 10(vi00)
		
	mr32 negangles, posangles
	mr32 negangles, negangles
	
	ilw.z count, 7(vi00)z  ;count is in z
	ilw.y stat, 11(vi00)y		
	;ilwr.x tagx, (iBase)x	   
	;iaddiu iMask, vi00, H'7fff; !!immediate has to be <= 15 bits wide
	;iaddiu iMask,iMask,1
	;iand tagx,tagx,iMask  ; clear all except bit 15
	
	;iaddiu buffer, vi00, 200
	;move dx, vf00
	;move.x dx, dxdy
	;move dy, vf00
	;move.y dy, dxdy
	;move saved_origin, origin	;save a copy
	
	ilw.w iPad, 1023(vi00)w
	ilw.x LastiPad, 11(vi00)x	

	iaddiu iMask, vi00, kLeft
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, LEFT_DOWN:
	 
	iaddiu iMask, vi00, kRight
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, RIGHT_DOWN:
	 
	iaddiu iMask, vi00, kUp
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, UP_DOWN:
	 
	iaddiu iMask, vi00, kDown
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, DOWN_DOWN:
	
	iaddiu iMask, vi00, kCross
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, CROSS_DOWN:
    
	iaddiu iMask, vi00, kTriangle
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, TRIANGLE_DOWN:

	iaddiu iMask, vi00, kSquare
	iaddiu iMask, iMask, 1
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, SQUARE_DOWN:

	iaddiu iMask, vi00, kCircle
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, CIRCLE_DOWN:

	b ONWARDS:

LEFT_DOWN:
	rotateYt Frame, posangles 
	b ONWARDS:
RIGHT_DOWN:
	rotateYt Frame, negangles
	b ONWARDS:
UP_DOWN:
	rotateXt Frame, posangles
	b ONWARDS:
DOWN_DOWN:
	rotateXt Frame, negangles
	b ONWARDS:

CROSS_DOWN:
	loi -1.0E-3
	lq vf01, 9(vi00)
	addi vf01, vf01, i
	sq vf01, 9(vi00)
	b ONWARDS:

TRIANGLE_DOWN:
	loi 1.0E-3
	lq vf01, 9(vi00)
	addi vf01, vf01, i
	sq vf01, 9(vi00)
	b ONWARDS:

SQUARE_DOWN:
	ibeq iPad, LastiPad, ONWARDS
	iaddiu itemp, vi00, kViewRear
	iand itemp, stat, itemp
	ibne itemp, vi00, VIEW_DRIVE
	iaddiu itemp, vi00, kViewRear
	ior stat,stat,itemp
	b ONWARDS
	
VIEW_DRIVE:
	iaddiu itemp, vi00, kNotViewRear
	iand stat,stat,itemp
	b ONWARDS	

CIRCLE_DOWN:
	ibeq iPad, LastiPad, ONWARDS
	iaddiu itemp, vi00, kWarp
	iand itemp, stat, itemp
	ibne itemp, vi00, WARP_VIEW
	iaddiu itemp, vi00, kWarp
	ior stat,stat,itemp
	b ONWARDS
	
WARP_VIEW:
	iaddiu itemp, vi00, kNotWarp
	iand stat,stat,itemp
	;b ONWARDS	
	
ONWARDS:
	isw.x iPad, 11(vi00)x
	;***init frame***

	normalise Frame			;TO DO
	
	iaddiu iKick,vi00, kTag0	;set kick location
	iaddiu idata_out,iKick,1	;set data out 
	iaddiu iFlag, vi00, 0		;clear swap buffer flag
					
	iaddiu scount,vi00, 0		;kick primis count

	ilw.w iHistory, 11(vi00)w 	;ihistory is in w
	ilw.z ticker, 11(vi00)z
	lq frameorigin, 0(iHistory)	;load frameorigin from last frame
	add acc, vf00, frameorigin 	;move frameorigin to accumulator
	
	lq vf01, 9(vi00)
	madd.x frameorigin, vf01, Frame[0][z]
	madd.y frameorigin, vf01, Frame[1][z]
	madd.z frameorigin, vf01, Frame[2][z]
	
	iaddiu nx ,vi00,0
	iaddiu ny ,vi00,0
	;ilw.z nx, 7(iBase)z
	;ilw.w ny, 7(iBase)w
	fcset 0

	;***add event***
	iaddi ticker, ticker, -1
	ibne ticker,vi00,TICK_DONE
	iaddiu ticker, vi00, kTicker
	iaddiu iHistory, iHistory, 1
	iaddiu itemp, vi00, kHistoryEnd		; 
	ibne iHistory, itemp, TICK_DONE		; iHistory == END
	iaddiu iHistory, vi00, kHistoryStart	; iHistory = 0

TICK_DONE:

	move viewFrame, Frame[2]
	iaddiu itemp, vi00, kViewRear
	iand itemp, stat, itemp
	ibeq itemp, vi00, NOT_REAR
	loi -1.0
	muli viewFrame, viewFrame,i

NOT_REAR:
	
	isw.y stat, 11(vi00)y
	isw.w iHistory, 11(vi00)w 		;save for next	frame
	isw.z ticker, 11(vi00)z
	sq Frame[0], 4(vi00)		;save the frame
	sq Frame[1], 5(vi00)
	sq Frame[2], 6(vi00)
	sq frameorigin, 0(iHistory)	;save new frameorigin
  
	iaddiu xPointer, vi00, kSin
	iaddiu yPointer, vi00, kSin
	
	lq xsindata, 0(xPointer)
	lq xcosdata, kSinSize(xPointer)
	lq ysindata, 0(yPointer)
	lq ycosdata, kSinSize(yPointer)

	iaddiu timer, vi00, 0
	sub ct1, vf00, vf00
	sub dr1, vf00, vf00
	sub prev_vertex, vf00, vf00
	lq origcolour, 8(vi00)
	sub fticker, vf00, vf00
	mfir.x fticker, ticker
	itof0.x fticker, fticker
	loi kLight
	muli fticker, fticker, i
LOOP_OUTER:
	
	iaddiu timer, vi00, 0
	move ct1, fticker
	move ct0, ct1
	move dr1, vf00
	move dr0, vf00
	
	;sub dr1, vf00, vf00
	;sub prev_vertex, vf00, vf00
	
	move thecolour, origcolour
	loi 0.8
	muli.x thecolour, origcolour, i
	
	lq frameorigin, 0(iHistory)
	
	sub basevertex, vf00, vf00
	loi 10.0
	addi.xyz basevertex, vf00, i
	mul.xy basevertex, basevertex, xsindata[x]
	mul.z basevertex, basevertex, xcosdata[x] 
	mul.x basevertex, basevertex, ysindata[x]
	mul.y basevertex, basevertex, ycosdata[x] 
	add basevertex, basevertex, origin
	add saved_vertex, basevertex, frameorigin 
	iaddiu hPointer, iHistory, 0		;set lower part
	iaddiu hGuard,vi00, kHistoryStart
	iaddiu itemp, vi00, kNotFlagH
	iand stat, stat, itemp
 	;iaddiu hFlag, vi00, 0
	
	ibne hPointer, hGuard, LOOP_INNER 	;no lower part	
						
	iaddiu hPointer, vi00, kHistoryEnd	;set upper part
	iaddiu hGuard, iHistory, 0
	iaddiu itemp, vi00, kFlagH
	ior stat, stat, itemp
	;iaddiu hFlag, vi00, 1

	; don't initialise in here
	; it gets skipped

LOOP_INNER:
	;--LoopCS 25,25
	 
	loi 0.97
	muli thecolour, thecolour, i
	move colour, thecolour
	add vertex, basevertex, frameorigin
	
	iaddiu itemp, vi00, kWarp
	iand itemp, stat, itemp
	ibeq itemp, vi00, TRANSFORM

	;b TRANSFORM

	eleng p, vertex		;	length of vector 
	mfp.w vertex, p		;	stored in w
	
	move prev_vertex, saved_vertex		
	move saved_vertex, vertex	;keep a copy
	
	move ct0, ct1
	loi kLightTick
	addi.x ct1, ct1,i 
	
	loi -1.0
	muli dr0, dr1, i
	;move dr0, dr1
	sub.x dr1, ct1, vertex[w]	; dr1=ct1-size
	clipw.xyz, ct1, vertex		; clip against size
	fcand vi01, H'0001		; check x>0 
	ibeq vi01, vi00, TOO_EARLY
	
	ibeq timer, vi00, TOO_EARLY	; need 2 vectors
	
	sub dvector, vertex, prev_vertex
	;sub.w dr1, prev_vertex, ct1	; 
	add.x sumx, dr1, dr0		;vf01.x=dr1-dr0
	
	;sub fraction, vf00, vf00
	div q, vf00[w], sumx[x]		
	mulq.w fraction, vf00, q		;vf01.w=1/dr0+dr1
	mul.w fraction, fraction, dr0		;vf01.w=-dr0/dr0+dr1
	mul dvector, dvector, fraction[w]	;dvec 
	
	;mr32 fraction, fraction
	;clipw.xyz fraction, vf00
	;fcand vi01, H'0003
	;ibne vi01, vi00, TOO_EARLY 
	
	add vertex, prev_vertex, dvector
	;move prev_vertex, saved_vertex
	
	; blues good
	loi 255.0
	muli colour, vf00, i
	mr32 colour, colour
	;mr32 colour, colour
		
	;;;stop this loop	
	iaddiu hPointer, hGuard, 1

	iaddiu itemp, vi00, kFlagH
	ior stat, stat, itemp  	

	;iaddiu hFlag, vi00, 1
		
	b TRANSFORM

TOO_EARLY:
	;move prev_vertex, vertex
		
	;iaddiu itemp, vi00, kWarp
	;iand itemp, stat, itemp
	;ibeq itemp, vi00, NEXT_VERTEX
	
	;b NEXT_VERTEX

TRANSFORM:

	;***begin transform***
	mul acc, Frame[0], vertex[x]	; 
	madd acc, Frame[1], vertex[y]	; 
	madd vertex, viewFrame, vertex[z]	; 
					; clip near < dz < far
	loi 0.1
	muli vf01, vf00, i
	clipw.xyz vertex, vf01
	fcand vi01, H'0010		; check -z 
	ibeq vi01, vi00, NEXT_VERTEX
	
	div q, vf00[w], vertex[z]	; 1/z
	;div q, window[z],pvert[z]
	mulq vertex,vertex,q		; dx/z dy/z dz/z

	loi 0.75
	mul vf01, vf00, i		; clip 0.75 x 0.75
	clipw.xyz vertex, vf01
	fcand vi01, H'000f		; check x,y only
	ibne vi01, vi00, NEXT_VERTEX
	
	mul vertex, vertex, window[z]	; x=320*dx/z 
	add.z vertex, vf00, q		; 
	loi 1000.0
	muli.z vertex, vertex, i	
		
	add.xy vertex,vertex,window	; 2048+320*dx/z
	ftoi4 vertex, vertex
	ftoi0 colour, colour
	sqi colour, (idata_out++)
	sqi vertex, (idata_out++)

	;***end transform***
	
	iaddiu scount,scount,1
	iaddiu iMask, vi00, 200
	ibne scount, iMask, NEXT_VERTEX

	;***kick***
	ilwr.x itemp, (vi00)x	   
	iaddiu iMask, vi00, H'7fff; !!immediate has to be <= 15 bits wide
	iaddiu iMask,iMask,1
	iand itemp,itemp,iMask  ; clear all except bit 15

	ior itemp,itemp,scount  ; set nloop bits
	iswr.x itemp,(iKick)x 	; store nloop

--barrier
	xgkick iKick		; flush this buffer
--barrier
	;iaddiu iKick,vi00,1
;--barrier
;	xgkick iKick		; send a NOP giftag
;--barrier	

	iaddiu scount, vi00, 0	;reset the counter

	ibeq iFlag, vi00, SET_BUFFER_2

	iaddiu iKick,vi00,kTag0
	iaddiu iFlag,vi00,0
	b SET_DONE

SET_BUFFER_2:
	iaddiu iKick,vi00,kTag1 	
	iaddiu iFlag,vi00,1

SET_DONE:	
	iaddiu idata_out,iKick,1
		
NEXT_VERTEX:

	;***history loop***
	lqd frameorigin, (--hPointer)		;load next location
	iaddiu timer, timer, 1
	ibne hPointer, hGuard, LOOP_INNER
	
	iaddiu itemp, vi00, kFlagH
	iand itemp, stat, itemp
	ibne itemp, vi00, NEXT_X
	
	;ibne hFlag, vi00, NEXT_X

	iaddiu hPointer, vi00, kHistoryEnd	;set upper part	
	iaddiu hGuard, iHistory, 0
	
	iaddiu itemp, vi00, kFlagH
	ior stat, stat, itemp
	
	;iaddiu hFlag, vi00, 1
	
	b LOOP_INNER

NEXT_X:
	;iaddiu timer, vi00, 0
	;***X loop***
	iaddiu,nx,nx,1
	iaddiu iMask, vi00, H'0003
	iand itemp, nx, iMask
	ibeq itemp, vi00, INC_X
	mr32 xsindata, xsindata
	mr32 xcosdata, xcosdata
	b DO_X
	
	INC_X:
	iaddiu xPointer, xPointer, 1
	lq xsindata, 0(xPointer)
	lq xcosdata, kSinSize(xPointer)
	
	DO_X:

	iadd itemp, count, count
	ibne nx,itemp,LOOP_OUTER

	;***Y loop***
	iaddiu,ny,ny,1
	iaddiu iMask, vi00, H'0003
	iand itemp, ny, iMask
	ibeq itemp, vi00, INC_Y
	mr32 ysindata, ysindata
	mr32 ycosdata, ycosdata
	b DO_Y
	
	INC_Y:
	iaddiu yPointer, yPointer, 1
	lq ysindata, 0(yPointer)
	lq ycosdata, kSinSize(yPointer)
	DO_Y:
	
	iaddiu,nx,vi00,0
	iaddiu xPointer, vi00, kSin
	lq xsindata, 0(xPointer)
	lq xcosdata, kSinSize(xPointer)
	ibne ny,count,LOOP_OUTER

	;***last kick***
	ilwr.x itemp, (vi00)x	   
	iaddiu iMask, vi00, H'7fff; !!immediate has to be <= 15 bits wide
	iaddiu iMask,iMask,1
	iand itemp,itemp,iMask		;clear all except bit 15
	ior itemp,itemp,scount  	;set nloop bits
	iswr.x itemp, (iKick)x 		;store nloop
	
--barrier
	xgkick iKick
FINISH:
--cont
	b START
.END
