; plasmatunnel v0.2
; exoticorn/farbrausch

OBUF		.equ	1

.macro fakesin out, in		; in [0..1] (full circle), out [-1..1]
	loi			4
	mul			acc, \in, i
	loi			0x800000*4
	madd		acc, one, i
	msub		acc, one, i
	loi			4
	msub		acc, \in, i
	loi			3
	madd		sintmp, one, i
	max			sintmp2, sintmp, one
	mini		sintmp, sintmp, one
	loi			2
	sub			sintmp2, sintmp2, i
	mul			sintmp2, sintmp2, sintmp2
	mul			acc, sintmp, sintmp
	msub		\out, one, sintmp2
.endm

.vu
.syntax new

--enter
	.init_vi_all
	.init_vf_all
--endenter

	; clear them for the moment
	sub	angle, vf0, vf0
	sub	s0, vf0, vf0
	sub	tpos, vf0, vf0
	sub	u, vf0, vf0
	sub tmp, vf0, vf0
	sub	sgn, vf0, vf0
	sub	v, vf0, vf0
	esadd p, s0			; clear p as well

	loi			0x8004				; nloop = 4
	add.x		giftag, vf0, i
	loi			0x20004000			; point, 2 regs
	add.y		giftag, vf0, i
	loi			0x51				; rgba, xyz2
	add.z		giftag, vf0, i
	ftoi0.xyz	giftag, giftag
	sq.xyz		giftag, OBUF(vi0)		; store giftag

	sub			pos, vf0, vf0
	loi			321.5
	add.x		pos, vf0, i
	loi			223
	add.y		pos, vf0, i			; topleft position

	loi			0x80000 + 2048.5
	add.x		center, vf0, i
	loi			0x80000 + 2047
	add.y		center, vf0, i		; screen center

	add.x		scale, vf0, vf0[w]
	loi			0.5
	add.y		scale, vf0, i		; screen scale

	add			one, vf0, vf0[w]
	mul.w		one, vf0, vf0		; 1, 1, 1, 1 constant

	loi			-0.75
	mul			brightscale, one, i
	
	iaddiu		ycnt, vi0, 112

	; load time
	lq			time, 0(vi0)
	itof0		time, time
	loi			-1.0/155 * 0.7
	mul.x		time, time, i
	loi			1.0/87 * 0.7
	mul.y		time, time, i
	loi			0.1/87 * 0.7
	mul.z		time, time, i
	loi			1.7145/870 * 0.7
	mul.w		time, time, i

	mfir		pos0, vi0
	mfir		pos1, vi0

	loi			128
	add			colscale, vf0, i
	loi			110
	add.z		colscale, vf0, i
	
yloop:
	iaddiu		xcnt, vi0, 322

.aif 1 eq 1		; handoptimised version?

.raw
xloop:
	add			u, u, time[z]
=	div			q, sgn[x], tmp[x]
	sub.x		pos, pos, one
=	loi			-0.75
	mul			acc, v, i
=	nop
	madd		shade, one, one
=	mfp.x		tpos, p
	add			v, v, time[y]
=	loi			3
	mul			angle1, u, i
=	nop
	mini.x		spos, pos, pos[y]
=	nop
	max			shade, shade, vf0[x]
=	nop
	mul.x		tpos, tpos, q
=	nop
	sub			tmp, one, q
=	loi			4
	mul			acc, angle1, i
=	loi			0x800000 * 4
	madd		acc, one, i
=	nop
	msub		acc, one, i
=	loi			4
	msub		acc, angle1, i
=	loi			2
	madd		sintmp_1, one, i
=	nop
	max.y		spos, pos, pos[x]
=	loi			0.78539816
	mul			acc, tmp, i
=	nop
	madd		u2, one, tpos[x]
=	nop
	mini		sintmp2_1, sintmp_1, vf0[x]
=	loi			2.3
	mul			angle2, v, i
=	loi			1.738
	mul			acc, v, i
=	nop
	max			sintmp_1, sintmp_1, vf0[x]
=	nop
	add			sintmp2_1, sintmp2_1, one
=	loi			0.6
	madd		acc, s0, i
=	nop
	madd		angle3, one, time[w]
=	nop
	sub			sintmp_1, sintmp_1, one
=	nop
	mul			sintmp2_1, sintmp2_1, sintmp2_1
=	loi			4
	mul			acc, angle2, i
=	loi			0x800000 * 4
	madd		acc, one, i
=	erleng		p, pos
	msub		acc, one, i
=	loi			4
	msub		acc, angle2, i
=	loi			2
	madd		sintmp_2, one, i
=	loi			4
	mul			acc, angle3, i
=	loi			0x800000 * 4
	madd		acc, one, i
=	nop
	msub		acc, one, i
=	loi			4
	msub		acc, angle3, i
=	loi			2
	madd		sintmp, one, i
=	nop
	mini		sintmp2_2, sintmp_2, vf0[x]
=	nop
	mul			acc, sintmp_1, sintmp_1
=	nop
	msub		s1, one, sintmp2_1
=	nop
	mini		sintmp2, sintmp, vf0[x]
=	nop
	max			sintmp_2, sintmp_2, vf0[x]
=	nop
	add			sintmp2_2, sintmp2_2, one
=	nop
	max			sintmp, sintmp, vf0[x]
=	nop
	add			sintmp2, sintmp2, one
=	nop
  sub	sintmp_2, sintmp_2, one
= nop
  mul	sintmp2_2, sintmp2_2, sintmp2_2
= nop										; BAD stalls, but it's not easy to fix at the moment
	mul			acc, sintmp_2, sintmp_2
=	nop
	msub		acc, one, sintmp2_2
=	nop
	sub			sintmp, sintmp, one
=	nop
	mul			sintmp2, sintmp2, sintmp2
=	nop
	madd		tex, one, s1
=	loi			1.0/4/1.57079632
	mul			u, u2, i
=	nop
	mul			acc, sintmp, sintmp
=	nop
	msub		acc, one, sintmp2
=	nop
	madd		tex, one, tex
=	eatanxy		p, spos
	nop			; what is missing?  ...Well, see the stalls above
=	nop
	sub.yz		u, vf0, u
=	nop
	mul			tpos, one, tpos[y]
=	nop
	max			tex2, tex, vf0[x]
=	nop
	mini		tmp, tex, vf0[x]
=	loi			0.5
	add.zw		u, u, i
=	loi			25
	mul			v, tpos, i
=	nop
	add			acc, tex2, one
=	loi			-0.1
	madd		tex, tmp, i
=	loi			5
	mul			acc, u, i
=	nop
	madd		acc, one, time[x]
=	loi			0x8000
	madd		angle0, one, i
=	loi			4
	mul			acc, tex, i
=	loi			0x800000 * 4
	madd		acc, one, i
=	iaddiu		obuf, vi0, OBUF
	msub		acc, one, i
=	loi			4
	msub		acc, tex, i
=	loi			2
	madd		sintmp, one, i
=	loi			4
	mul			acc, angle0, i
=	loi			0x800000 * 4
	madd		acc, one, i
=	nop
	msub		acc, one, i
=	nop
	mini		sintmp2, sintmp, vf0[x]
=	loi			4
	msub		acc, angle0, i
=	loi			2
	madd		sintmp_0, one, i
=	nop
	max			sintmp, sintmp, vf0[x]
=	nop
	add			sintmp2, sintmp2, one
=	nop
	nop			; what is missing?  ...s.o.
=	nop
	mini		sintmp2_0, sintmp_0, vf0[x]
=	nop
	sub			sintmp, sintmp, one
=	nop
	mul			sintmp2, sintmp2, sintmp2
=	move.x		pos2, pos0
	max			sintmp_0, sintmp_0, vf0[x]
=	sq			pos0, OBUF+2(vi0)
	add			sintmp2_0, sintmp2_0, one
=	sq			pos1, OBUF+8(vi0)
	mul			acc, sintmp, sintmp
=	move.x		pos0, pos1
	msub		acc, one, sintmp2
=	move.x		pos1, pos2
	madd		tex, one, one
=	nop
	sub			sintmp_0, sintmp_0, one
=	nop
	mul			sintmp2_0, sintmp2_0, sintmp2_0
=	sq			pos0, OBUF+4(vi0)
	sub.x		sgn, pos, pos[y]
=	sq			pos1, OBUF+6(vi0)
	mul			tex, tex, shade
=	nop
	mul			acc, sintmp_0, sintmp_0
=	nop
	msub		s0, one, sintmp2_0
=	loi			0x800000
	mul			acc, one, i
=	nop
	madd		rgba0, colscale, tex[x]
=	nop
	madd		rgba1, colscale, tex[y]
=	isubiu		xcnt, xcnt, 1
	madd		rgba2, colscale, tex[z]
=	mfp.y		tpos, p
	madd		rgba3, colscale, tex[w]
=	loi			4
	add			s0, s0, i
=	sq			rgba0, OBUF+1(vi0)
	add.xy		acc, vf0, center
=	sq			rgba1, OBUF+3(vi0)
	abs.x		tmp, sgn
=	sq			rgba2, OBUF+5(vi0)
	msub.xy		pos0, scale, pos
=	sq			rgba3, OBUF+7(vi0)
	mul			v, v, s0
=	ibne		xcnt, vi0, xloop
	madd.xy		pos1, scale, pos
=	xgkick		obuf
.endraw

.aelse
	
xloop:
;--loopCS 320, 0
	; calculate screen postions and store them
	add.xy		acc, vf0, center
	msub.xy		pos0, scale, pos
	madd.xy		pos1, scale, pos
	sq			pos0, OBUF+2(vi0)
	sq			pos1, OBUF+8(vi0)
	move		pos2, pos0
	move.x		pos0, pos1
	move.x		pos1, pos2
	sq			pos0, OBUF+4(vi0)
	sq			pos1, OBUF+6(vi0)
	
	; calc position on tunnel
.aif 1 eq 1										; use emulated ERLENG?
	mul			tmp, pos, pos
	add.x		tmp, tmp, tmp[y]
	add.x		tmp, tmp, tmp[z]
	rsqrt		q, vf0[w], tmp[x]
	add.yz		tpos, vf0, q
.aelse
	erleng		p, pos
	mfp.yz		tpos, p
.aendi
	mini.x		spos, pos, pos[y]
	max.y		spos, pos, pos[x]				; sort x, y
	eatanxy		p, spos
	mfp.x		tpos, p
	sub.x		sgn, pos, pos[y]
	abs.x		tmp, sgn
	div			q, sgn[x], tmp[x]				; calc the sign of x-y
	mul.x		tpos, tpos, q
	sub			tmp, one, q
	loi			0.78539816						; pi/4
	mul			acc, tmp, i
	madd		u, one, tpos[x]
	loi			1.0/4/1.57079632
	mul			u, u, i
	sub.yz		u, vf0, u
	loi			0.5
	add.zw		u, u, i
	loi			25
	mul			tpos, one, tpos[y]
	mul			v, tpos, i

	; deform tunnel
	loi			5
	mul			acc, u, i
	madd		acc, one, time[x]
	loi			0x8000
	madd		angle, one, i
	fakesin		s0, angle
	loi			4
	add			s0, s0, i
	mul			v, v, s0

	; calc brightness
	loi			-0.75
	mul			acc, v, i
	loi			1
	madd		tpos, one, i
	max			tpos, tpos, vf0[x]

	; move tunnel
	add			v, v, time[y]
	add			u, u, time[z]

	; generate texture
	loi			3
	mul			angle, u, i
	fakesin		s1, angle
	loi			2.3
	mul			angle, v, i
	fakesin		s2, angle
	add			tex, s1, s2
	loi			1.738
	mul			acc, v, i
	loi			0.6
	madd		acc, s0, i
	madd		angle, one, time[w]
	fakesin		s3, angle
	add			tex, tex, s3
	mini		tmp, tex, vf0[x]
	max			tex, tex, vf0[x]
	loi			-0.1
	add			acc, tex, vf0[w]
	madd		tex, tmp, i
	fakesin		tex, tex
	add			tex, tex, one
	mul			tex, tex, tpos

	loi			0x800000					; ftoi bias
	mul			acc, one, i
	
	madd		rgba, colscale, tex[x]
	sq			rgba, OBUF+1(vi0)
	
	madd		rgba, colscale, tex[y]
	sq			rgba, OBUF+3(vi0)
	
	madd		rgba, colscale, tex[z]
	sq			rgba, OBUF+5(vi0)
	
	madd		rgba, colscale, tex[w]
	sq			rgba, OBUF+7(vi0)
	
	; draw dots
	iaddiu		obuf, vi0, OBUF
	xgkick		obuf

	; inc position
	sub.x		pos, pos, vf0[w]
	isubiu		xcnt, xcnt, 1
	ibne		xcnt, vi0, xloop

.aendi
	
	loi			322
	add.x		pos, pos, i					; reset xpos
	loi			2
	sub.y		pos, pos, i					; inc ypos
	isubiu		ycnt, ycnt, 1
	ibne		ycnt, vi0, yloop

	ilw.x		time, 0(vi0)				; inc time
	iaddiu		time, time, 1
	isw.xyzw	time, 0(vi0)

--cont

--exitm
--endexit

.END
