.init_vf_all
.init_vi_all
.syntax new

.vu

kModelStart .assign 0
kModelEnd .assign 107
kCubesStart .assign 108
kCubesEnd .assign 307
kObjectToWorld .assign 308
kWorldToCamera .assign 312
kCameraToScreen .assign 316
kScales .assign 320
kDummyTag .assign 321
kBuffer1 .assign 322
kBuffer1End .assign 538
kBuffer2 .assign 539
kBuffer2End .assign 755
kTextureUpload .assign 323
kCameraPos .assign 1021       ; (Alpha, r, Theta, rMin)
kState .assign 1022
kLastQWord .assign 1023

kSquare .assign H'7FFF
kCross .assign H'4000
kTriangle .assign H'1000
kCircle .assign H'2000
kR1 .assign H'0800
kR2 .assign H'0200
kStart .assign H'0008
kLeft .assign H'0080
kDown .assign H'0040
kUp .assign H'0010
kRight .assign H'0020

	.include "vcl_sml.i"

	--enter
	in_vi iBufferPointer(VI15)
	--endenter

START:
	fcset 0

	ilw.x iState, kState(vi00)
	ibeq iState, vi00, INIT:
	
INIT_DONE:

	ilw.w iPad, kLastQWord(vi00)
	iaddiu iMask, vi00, kR1
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ZOOM_OUT:
	iaddiu iMask, vi00, kR2
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ZOOM_IN:
ZOOM_DONE:
	iaddiu iMask, vi00, kLeft
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ALPHA_UP:
	iaddiu iMask, vi00, kRight
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ALPHA_DOWN:
ALPHA_DONE:
	iaddiu iMask, vi00, kUp
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, THETA_UP:
	iaddiu iMask, vi00, kDown
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, THETA_DOWN:
THETA_DONE:
	b PAD_DONE:

ZOOM_OUT:
	lq.y fCameraPos, kCameraPos(vi00)
	loi 0.1
	add.y fCameraPos, fCameraPos, i
	sq.y fCameraPos, kCameraPos(vi00)
	b ZOOM_DONE:
ZOOM_IN:
	lq fCameraPos, kCameraPos(vi00)
	;clipw.xyz fCameraPos, fCameraPos
	;fcand vi01, 0x04
	;ibeq vi01, vi00, ZOOM_DONE:
	
	; If r > rmin
	loi 0.1
	sub.y fCameraPos, fCameraPos, i 
	sq.y fCameraPos, kCameraPos(vi00)
	b ZOOM_DONE:

ALPHA_UP:
	lq.x fCameraPos, kCameraPos(vi00)
	loi 5e-2
	add.x fCameraPos, fCameraPos, i
	sq.x fCameraPos, kCameraPos(vi00)
	b ALPHA_DONE:
ALPHA_DOWN:
	lq.x fCameraPos, kCameraPos(vi00)
	loi 5e-2
	sub.x fCameraPos, fCameraPos, i 
	sq.x fCameraPos, kCameraPos(vi00)
	b ALPHA_DONE:

THETA_UP:
	lq.z fCameraPos, kCameraPos(vi00)
	loi 5e-2
	add.z fCameraPos, fCameraPos, i
	sq.z fCameraPos, kCameraPos(vi00)
	b THETA_DONE:
THETA_DOWN:
	lq.z fCameraPos, kCameraPos(vi00)
	loi 5e-2
	sub.z fCameraPos, fCameraPos, i 
	sq.z fCameraPos, kCameraPos(vi00)
	b THETA_DONE:

PAD_DONE:

	lq.xyz fCameraPos, kCameraPos(vi00)	
	AngleSinCos fCameraPos, fSinCos ; fSinCos = (sa, ca, st, ct)

	MatrixIdentity mRotateTheta
	MatrixIdentity mRotateAlpha
	MatrixIdentity mTranslate

	mul.y mRotateTheta[1], mRotateTheta[1], fSinCos[w]
	sub.z mRotateTheta[1], mRotateTheta[1], fSinCos[z]
	add.y mRotateTheta[2], mRotateTheta[2], fSinCos[z]
	mul.z mRotateTheta[2], mRotateTheta[2], fSinCos[w]

	mul.x mRotateAlpha[0], mRotateAlpha[0], fSinCos[y]
	sub.z mRotateAlpha[0], mRotateAlpha[0], fSinCos[x]
	add.x mRotateAlpha[2], mRotateAlpha[2], fSinCos[x]
	mul.z mRotateAlpha[2], mRotateAlpha[2], fSinCos[y]

	sub.xyz fTemp, vf00, fCameraPos[y]
	mul.xz fTemp, fTemp, fSinCos[w]
	mul.y fTemp, fTemp, fSinCos[z]
	mul.z fTemp, fTemp, fSinCos[y]
	mul.x fTemp, fTemp, fSinCos[x]

	mul.w mTranslate[0], vf00, fTemp[x]
	mul.w mTranslate[1], vf00, fTemp[y]
	mul.w mTranslate[2], vf00, fTemp[z]

	MatrixMultiply mWorldToCamera, mRotateTheta, mRotateAlpha
	MatrixMultiply mWorldToCamera, mWorldToCamera, mTranslate

	MatrixTranspose mWorldToCamera, mWorldToCamera

	VectorLoad fScales, kScales, vi00 ;VCL will prune off W field
	;MatrixLoad mWorldToCamera, kWorldToCamera, vi00
	MatrixLoad mCameraToScreen, kCameraToScreen, vi00

	iaddiu iCubePointer, vi00, kCubesStart
	iaddiu iCubesEnd, vi00, kCubesEnd + 1

CUBE_LOOP:
	MatrixLoad mObjectToWorld, kObjectToWorld, vi00
	lq fTranslation, 0(iCubePointer)
	lq fAxisAngle, 1(iCubePointer)	
	loi 5e-2
	add.w fAxisAngle, fAxisAngle, i
	sq fAxisAngle, 1(iCubePointer)

	sub fAngle, vf00, vf00
	mr32.z fAngle, fAxisAngle
	AngleSinCos fAngle, fSinCosAngle
	MatrixIdentity mRotation
	mul.xyz fSquares, fAxisAngle, fAxisAngle
	sub.x mRotation[0], mRotation[0], fSquares
	sub.y mRotation[1], mRotation[1], fSquares
	sub.z mRotation[2], mRotation[2], fSquares
	mul.x mRotation[0], mRotation[0], fSinCosAngle[w]
	mul.y mRotation[1], mRotation[1], fSinCosAngle[w]
	mul.z mRotation[2], mRotation[2], fSinCosAngle[w]
	add.x mRotation[0], mRotation[0], fSquares
	add.y mRotation[1], mRotation[1], fSquares
	add.z mRotation[2], mRotation[2], fSquares

	sub.w fSinCosAngle, vf00, fSinCosAngle
	mul.yz mRotation[0], fAxisAngle, vf00[w]
	mul.xz mRotation[1], fAxisAngle, vf00[w]
	mul.xy mRotation[2], fAxisAngle, vf00[w]
	mul.yz mRotation[0], mRotation[0], fAxisAngle[x]
	mul.xz mRotation[1], mRotation[1], fAxisAngle[y]
	mul.xy mRotation[2], mRotation[2], fAxisAngle[z]
	mul.yz mRotation[0], mRotation[0], fSinCosAngle[w]
	mul.xz mRotation[1], mRotation[1], fSinCosAngle[w]
	mul.xy mRotation[2], mRotation[2], fSinCosAngle[w]
	mul.xyz fAxisangle, fAxisangle, fSinCosAngle[z]
	sub.y mRotation[0], mRotation[0], fAxisAngle[z]
	add.z mRotation[0], mRotation[0], fAxisAngle[y]
	sub.z mRotation[1], mRotation[1], fAxisAngle[x]
	add.x mRotation[1], mRotation[1], fAxisAngle[z]
	sub.x mRotation[2], mRotation[2], fAxisAngle[y]
	add.y mRotation[2], mRotation[2], fAxisAngle[x]
	;Phew!  That was painstaking. Probably v. inefficient...
	
	mul.x mObjectToWorld[0], mObjectToWorld[0], fTranslation[w]
	mul.y mObjectToWorld[1], mObjectToWorld[1], fTranslation[w]
	mul.z mObjectToWorld[2], mObjectToWorld[2], fTranslation[w]
	move.xyz mObjectToWorld[3], fTranslation

	MatrixTranspose mObjectToWorld, mObjectToWorld
	MatrixMultiply mObjectToWorld, mObjectToWorld, mRotation
	MatrixTranspose mObjectToWorld, mObjectToWorld

	MatrixMultiply mObjectToScreen, mObjectToWorld, mWorldToCamera
	MatrixMultiply mObjectToScreen, mObjectToScreen, mCameraToScreen

	;Loop through transforming each model vertex, storing transformed verts into GIFtag.
	iaddiu iVertPointer, vi00, kModelStart
	iaddiu iVertEnd, vi00, kModelEnd + 1

	iaddiu iClipCounter, vi00, 3 ; Clip only every 3rd vertex
	iaddiu iClip, vi00, 0
	
TRANSFORM_LOOP:
	VertexLoad vSTQ, 0, iVertPointer
	VertexLoad vRGBA, 1, iVertPointer
	VertexLoad vVert, 2, iVertPointer
	
	MatrixMultiplyVertex vVert, mObjectToScreen, vVert

	;Clip now against w field.
	clipw.xyz vVert, vVert
	isubiu iClipCounter, iClipCounter, 1
	ibne iClipCounter, vi00, SKIP_CLIP:
	fcand vi01, 0x3ffff
	iaddiu iClip, vi01, 0x7fff

	;Backface culling here would probably correct garbage when you 
	;crash into a cube, but Ive run out of time before the demo 
	;deadline... :(
	
SKIP_CLIP:
	;Alternative perspective correction, to make use of fScales
	div q, vf00[w], vVert[w]
	mul.xyz acc, fScales, vVert[w]
	madd.xyz vVert, vVert, fScales
	mul.xyz vVert, vVert, q
	mul.xyz vSTQ, vSTQ, q
	
	VertexFptoGsXYZ2 vVert, vVert
	mfir.w vVert, iClip
 
	loi 255
	mul vRGBA, vRGBA, i
	ColorFPtoGsRGBAQ vRGBA, vRGBA
	VertexSave vSTQ, 0, iBufferPointer
	VertexSave vRGBA, 1, iBufferPointer
	VertexSave vVert, 2, iBufferPointer
	iaddiu iVertPointer, iVertPointer, 3
	iaddiu iBufferPointer, iBufferPointer, 3
	ibne iVertPointer, iVertEnd, TRANSFORM_LOOP:

	iaddiu iBuffer1End, vi00, kBuffer1End + 1
	iaddiu iBuffer2End, vi00, kBuffer2End + 1
	ibeq iBufferPointer, iBuffer1End, BUFFER_1_END:
	ibeq iBufferPointer, iBuffer2End, BUFFER_2_END:
BUFFER_CHECKED:
	iaddiu iCubePointer, iCubePointer, 2
	ibne iCubePointer, iCubesEnd, CUBE_LOOP:
	
	b END ; No need for buffer cleanup if NUM_CUBES is even

BUFFER_1_END:
	iaddiu iBuffer1, vi00, kBuffer1
	xgkick iBuffer1
	iaddiu iBufferPointer, vi00, kBuffer2 + 1
	b BUFFER_CHECKED
BUFFER_2_END:
	iaddiu iBuffer2, vi00, kBuffer2
	xgkick iBuffer2
	iaddiu iBufferPointer, vi00, kBuffer1 + 1
	b BUFFER_CHECKED

INIT:
	iaddiu iTextureUpload, vi00, kTextureUpload
	xgkick iTextureUpload
	iaddiu iDummy, vi00, kDummyTag
	xgkick iDummy ; Forces VU to stall until texture upload is complete
	isw.x iTextureUpload, kState(vi00)
	lq fGiftag, kBuffer1(vi00)
	sq fGiftag, kBuffer2(vi00)
	iaddiu iBufferPointer, vi00, kBuffer1 + 1
	sub fCameraPos, vf00, vf00
	loi 10.0
	add.y fCameraPos, fCameraPos, i
	loi 5.55
	add.w fCameraPos, fCamerapos, i
	sq fCameraPos, kCameraPos(vi00)
	b INIT_DONE
	
END:

	--exit
	out_vi iBufferPointer(VI15)
	--endexit

.END
