.init_vf_all
.init_vi_all
.syntax new

.vu

kModelStart .assign 0
kModelEnd .assign 71
kCubeTag .assign 72
kCubeStart .assign 73
kCubeEnd .assign 180
kObjectToWorld .assign 181
kWorldToCamera .assign 185
kCameraToScreen .assign 189
kRotate .assign 193
kScales .assign 197
kTextureUploadTag .assign 198
kTextureDataTag .assign 203
kTextureData .assign 207
kTextureEnd .assign 715
kTextureDone .assign 1022
kLastQWord .assign 1023

kSquare .assign H'7FFF
kCross .assign H'4000
kTriangle .assign H'1000
kCircle .assign H'2000
kR1 .assign H'0800
kR2 .assign H'0200
kStart .assign H'0008
kLeft .assign H'0080
kDown .assign H'0040
kUp .assign H'0010
kRight .assign H'0020

	.include "vcl_sml.i"

--enter
--endenter

START:
	ilw.x iTextureDone, kTextureDone(vi00)
	ibeq iTextureDone, vi00, UPLOAD_TEXTURE:
	
TEXTURE_DONE:

	ilw.w iPad, kLastQWord(vi00)
	iaddiu iMask, vi00, kR1
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ZOOM_OUT:
	iaddiu iMask, vi00, kR2
	iand iCheck, iPad, iMask
	ibeq iCheck, vi00, ZOOM_IN:
	b ZOOM_DONE:
ZOOM_OUT:
	lq.z fCameraZoom, (kWorldToCamera+3)(vi00)
	loi 0.1
	sub.z fCameraZoom, fCameraZoom, i 
	sq.z fCameraZoom, (kWorldToCamera+3)(vi00)
	b ZOOM_DONE:
ZOOM_IN:
	lq.z fCameraZoom, (kWorldToCamera+3)(vi00)
	loi 0.1
	add.z fCameraZoom, fCameraZoom, i 
	sq.z fCameraZoom, (kWorldToCamera+3)(vi00)
ZOOM_DONE:
	
	VectorLoad fScales, kScales, vi00

	MatrixLoad mObjectToWorld, kObjectToWorld, vi00
	MatrixLoad mWorldToCamera, kWorldToCamera, vi00	
	MatrixLoad mCameraToScreen, kCameraToScreen, vi00
	MatrixLoad mRotate, kRotate, vi00

	;This is where you would normally modify the mObjectToWorld matrix
	;to orientate and palce you object in the correct position
	;Uncomment these to see what happens when rounding errors accumulate.
	;Then comment out the two lines in the TRANSFORM_LOOP below
	;MatrixMultiply mObjectToWorld, mRotate, mObjectToWorld
	;MatrixSave mObjectToWorld, kObjectToWorld, vi00

	;Compute Object to Screen matrix (Object to World * World to Camera * Camera to Screen)
	MatrixMultiply mObjectToScreen, mObjectToWorld, mWorldToCamera
	MatrixMultiply mObjectToScreen, mObjectToScreen, mCameraToScreen

	;Loop through transforming each model vertex, storing transformed verts into GIFtag.
	iaddiu iVertPointer, vi00, kModelStart
	iaddiu iVertEnd, vi00, kModelEnd + 1
	iaddiu iStoreTo, vi00, kCubeStart
	
TRANSFORM_LOOP:
	VertexLoad vST, 0, iVertPointer
	VertexLoad vVert, 1, iVertPointer

	;If you uncommented the 2 lines above, comment these out.
	;You would *not* normally modify the original model values here, I have
	;only done so for the sake of simplicity.
	MatrixMultiplyVertex vVert, mRotate, vVert
	VertexSave vVert, 1, iVertPointer

	MatrixMultiplyVertex vVert, mObjectToScreen, vVert

	;Alternative perspective correction, to make use of fScales
	div q, vf00[w], vVert[w]
	mul.xyz acc, fScales, vVert[w]
	madd.xyz vVert, vVert, fScales
	mul.xyz vVert, vVert, q
	mul.xyz vST, vST, q
	
	VertexFptoGsXYZ2 vVert, vVert ; Translates from Floating Point to 12:4 fixed point, and adds 2048
	VertexSave vST, 0, iStoreTo
	VertexSave vVert, 2, iStoreTo
	iaddiu iVertPointer, iVertPointer, 2
	iaddiu iStoreTo, iStoreTo, 3
	ibne iVertPointer, iVertEnd, TRANSFORM_LOOP:

KICK:
	iaddiu iCubeTag, vi00, kCubeTag
	xgkick iCubeTag
	b END

UPLOAD_TEXTURE:
	iaddiu iTextureUpload, vi00, kTextureUploadTag
	xgkick iTextureUpload
	isw.x iTextureUpload, kTextureDone(vi00)
	b TEXTURE_DONE
	
END:

--exit
--endexit

.END
