// gs.h
// Copyright (C)2003 Martin Piper (mindor@playstation2-linux.com)

// some useful macros for setting GIFTags and GS registers

#ifndef R_GS_H
#define R_GS_H

#define GIFTAG31_0(eop,nloop) (((int)(eop << 15)) |((int)(nloop << 0)))
#define GIFTAG63_32(nreg,flg,prim,pre) \
(((int)(nreg << 28))|((int)(flg << 26))|((int)(prim << 15))|((int)(pre << 14)))
#define GIFTAG_REGS(r8,r7,r6,r5,r4,r3,r2,r1)\
(((int)(r1 << 0))|((int)(r2 << 4))|((int)(r3 << 8))|((int)(r4 << 12))|\
((int)(r5 << 16))|((int)(r6 << 20))|((int)(r7 << 24))|((int)(r8 << 28)))


//
//register tags

#define GSR_PRIM              0x00
#define GSR_RGBAQ             0x01
#define GSR_ST                0x02
#define GSR_UV                0x03
#define GSR_XYZF2             0x04
#define GSR_XYZ2              0x05
#define GSR_TEX0_1            0x06
#define GSR_TEX0_2            0x07
#define GSR_CLAMP_1           0x08
#define GSR_CLAMP_2           0x09
#define GSR_FOG               0x0a
#define GSR_XYZF3             0x0c
#define GSR_XYZ3              0x0d

#define GSR_TEX1_1            0x14
#define GSR_TEX1_2            0x15
#define GSR_TEX2_1            0x16
#define GSR_TEX2_2            0x17
#define GSR_XYOFFSET_1        0x18
#define GSR_XYOFFSET_2        0x19
#define GSR_PRMODECONT        0x1a
#define GSR_PRMODE            0x1b
#define GSR_TEXCLUT           0x1c

#define GSR_SCANMSK           0x22

#define GSR_MIPTBP1_1         0x34
#define GSR_MIPTBP1_2         0x35
#define GSR_MIPTBP2_1         0x36
#define GSR_MIPTBP2_2         0x37
#define GSR_TEXA              0x3b
#define GSR_FOGCOL            0x3d
#define GSR_TEXFLUSH          0x3f

#define GSR_SCISSOR_1         0x40
#define GSR_SCISSOR_2         0x41
#define GSR_ALPHA_1           0x42
#define GSR_ALPHA_2           0x43
#define GSR_DIMX              0x44
#define GSR_DTHE              0x45  
#define GSR_COLCLAMP          0x46
#define GSR_TEST_1            0x47
#define GSR_TEST_2            0x48
#define GSR_PABE              0x49
#define GSR_FBA_1             0x4a
#define GSR_FBA_2             0x4b
#define GSR_FRAME_1           0x4c
#define GSR_FRAME_2           0x4d
#define GSR_ZBUF_1            0x4e
#define GSR_ZBUF_2            0x4f

#define GSR_BITBLTBUF         0x50
#define GSR_TRXPOS            0x51
#define GSR_TRXREG            0x52
#define GSR_TRXDIR            0x53
#define GSR_HWREG             0x54
#define GSR_SIGNAL            0x60
#define GSR_FINISH            0x61
#define GSR_LABEL             0x62

// Primitive types

#define GS_PRIM_POINT         0 // 000
#define GS_PRIM_LINE          1 // 001
#define GS_PRIM_LINE_S        2 // 010
#define GS_PRIM_TRI           3 // 011
#define GS_PRIM_TRI_S         4 // 100
#define GS_PRIM_TRI_F         5 // 101
#define GS_PRIM_SPRITE        6 // 110
                                // 111 prohibited
// Primitive settings
#define GS_PRIM_FLAT_SHADE    0
#define GS_PRIM_GOUR_SHADE    (1<<3)

#define GS_PRIM_TEX_ON        (1<<4)
#define GS_PRIM_TEX_OFF       0

#define GS_PRIM_FOG_OFF       0
#define GS_PRIM_FOG_ON        (1<<5)

#define GS_PRIM_ALPH_OFF      0
#define GS_PRIM_ALPH_ON       (1<<6)

#define GS_PRIM_ANTA_OFF      0
#define GS_PRIM_ANTA_ON       (1<<7)

#define GS_PRIM_STQ           0
#define GS_PRIM_UV            1

#define GS_PRIM_CTXT_1        0
#define GS_PRIM_CTXT_2        1

#define GS_PRIM_UNFIX         0
#define GS_PRIM_FIXED         1

//macro for setting PRIM /PRMODE registers, for PRMODE last arg = 0

//#define GS_PRIM(fix,ctxt,fst,aa1,abe,fge,tme,hp,prim)
#endif
