
; intro_winds.i
; Copyright (C) 2003 Martin Piper
;

.init_vf_all	;
.init_vi_all	;
.syntax new

; ***********************************************************************
; **************************** INTRO MODE B *****************************
; ***********************************************************************
intro_b:
	
	iaddiu	d_buf,	vi00,	D_BUFFER ;
	ilw.y	f_ctl,	CONT1(vi00)	 ;load frame control
 	LQ	c2s0,	C2S(vi00)	;load world to screen
	LQ	c2s1,	C2S+1(vi00)	;
	LQ	c2s2,	C2S+2(vi00)	;	
	LQ	c2s3,	C2S+3(vi00)	;
	
	iaddiu	tri_i,	vi00,	0	; triangle index. used for blow away feature
;**********   DRAW THE RHOMBUS *************
	bal     ret_ib_draw_rhombus, intro_b_draw_rhombus

;**********   DRAW THE WORDS****************

	iaddiu	letters,vi00, LETTERS_INTRO_B	; set which index we are displaying		
	bal	ret_ib_set_letter, set_letter	;
	
	iaddiu	f_ctl,	f_ctl,	1	; increment the frame

;********* CHECK IF WE ARE DONE WITH INTRO_B **************
	   
	iaddiu	max_frames,	vi00,		    MAX_FRAMES_B
	;********** if (f_ctl == max_frames ) done with mode b, set mode to c
	ibne	f_ctl,		max_frames,	    end_intro_b 
	iaddiu	mode,		vi00,		    MODE_INTRO_C
	iaddiu	f_ctl,		vi00,		    vi00
	isw.x	mode,		CONT1(vi00)

end_intro_b:
	
	isw.y	f_ctl,	CONT1(vi00)	; store for next time
	b exit

; ***************************************************************************
; ****************************** INTRO MODE C *******************************
; ***************************************************************************
intro_c:
	iaddiu	d_buf,	vi00,	D_BUFFER ;
	ilw.y	f_ctl,	CONT1(vi00)	 ;load frame control
 	LQ	c2s0,	C2S(vi00)	;load world to screen
	LQ	c2s1,	C2S+1(vi00)	;
	LQ	c2s2,	C2S+2(vi00)	;	
	LQ	c2s3,	C2S+3(vi00)	;
	
	iaddiu	tri_i,	vi00,	0	; triangle index. used for blow away feature
;TODO ADD RHOMBUS DRAWING HERE

      
;**********   DRAW THE WORDS****************

	iaddiu	letters,vi00, LETTERS_INTRO_C	; set which index we are displaying		
	bal	ret_ib_set_letter, set_letter	;
	
	iaddiu	f_ctl,	f_ctl,	1	; increment the frame

;********* CHECK IF WE ARE DONE WITH INTRO_C **************

	iaddiu	max_frames,	vi00,		    MAX_FRAMES_C
	;********** if (f_ctl == max_frames ) done with mode c, set mode to setup_main
	ibne	f_ctl,		max_frames,	    end_intro_b 
	iaddiu	mode,		vi00,		    MODE_SETUP_MAIN
	iaddiu	f_ctl,		vi00,		    vi00
	isw.x	mode,		CONT1(vi00)

end_intro_c:
	
	isw.y	f_ctl,	CONT1(vi00)	; store for next time
	b exit


; ****************************************************************************
; *                       INTRO B DRAW RHOMBUS                               *
; ****************************************************************************

intro_b_draw_rhombus:
	iaddiu	    max_row,	vi00,	20
	iaddiu	    max_col,	vi00,	10
	iaddiu	    unpack,	vi00,	INTRO_UNPACK_BUFFER

	iadd	    rhombus_row,	vi00, vi00
	iadd	    rhombus_column,	vi00, vi00
		
	lq	    rtv_math,	RTV_MATH(vi00)    
intro_b_set_rhombus_verts:
	mfir.x	    rtv,	rhombus_column
	itof0.x	    rtv,	rtv
	mulx.yzw    rtv,	vf00,	vf00

	
	mulw.x	    rtv,	rtv,	rtv_math	;rtv_math.w = 2.0
	sqi	    rtv,	(unpack++):dg1
	add.xy	    rtv,	rtv,	rtv_math	;rtv_math.x = 0.5
						;rtv_math.y = -cos(30) 
	sqi	    rtv,	(unpack++):dg1
	add.x	    rtv,	rtv,	rtv_math	
	move.y	    rtv,	vf00,
	sqi	    rtv,	(unpack++):dg1
	add.xy	    rtv,	rtv,	rtv_math
	sqi	    rtv,	(unpack++):dg1

	iaddiu	    rhombus_column,	rhombus_column,	1
	ibne	    rhombus_column, max_col,	 intro_b_set_rhombus_verts
	
	move.y	    rtv,	vf00
	add.x	    rtv,	rtv,	rtv_math
	sqi	    rtv,	(unpack++)
	add.xy	    rtv,	rtv,	rtv_math
	sq	    rtv,	(unpack)
	iaddiu	    end_mark,	vi00,		1
	iswr.w	    end_mark,	(unpack)

intro_b_draw_rhombus_rows:
	lq	    l_offset,	RT_OFF(vi00)
	
	mfir.x      r_offset2,	rhombus_row
	itof0.x	    r_offset2,	r_offset2
	mulx.xy	    r_offset2,	rtv_math,	r_offset2

	add.xy	    l_offset,	l_offset,	r_offset2,
	iaddiu	    color,	vi00,		RED
	iaddiu	    letter,	vi00,		INTRO_UNPACK_BUFFER
	iaddiu	    nloop,	vi00,		0
	iaddiu	    o_buf,	vi00,		INTRO_O_BUFFER	


	LQ	    gt_tri,	GT_TRIANGLE(vi00)		;load triangle giftag
	SQI	    gt_tri,	(o_buf++)			;pack giftag
	
	bal	    ret_ib_draw_letter,     draw_letter

	iaddiu	    rhombus_row,	rhombus_row,	1
	ibne	    rhombus_row,	max_row,	intro_b_draw_rhombus_rows

	

	jr	ret_ib_draw_rhombus



; ************************************************************************************
; *                                 INTRO B/C SET LETTER                             *
; ************************************************************************************
	
set_letter:
	ilwr.z	package_pointer,   (letters):mg1		;load which letter to draw
	lq.xy	l_offset,	   (letters):mg1		;load x,y offset from 0

	iaddiu  unpack_buffer,	   vi00,	INTRO_UNPACK_BUFFER;
	bal	ret_unpack,	   unpack_package
	
	iaddiu	letter,		   vi00,	INTRO_UNPACK_BUFFER;		
	iaddiu	nloop,		   vi00,	0		;start nloop counter
	iaddiu	o_buf,		   vi00,	INTRO_O_BUFFER	;set output buffer
	iaddiu	color,		   vi00,	WHITE		;

	LQ	gt_tri,		   GT_TRIANGLE(vi00)		;load triangle giftag
	SQI	gt_tri,		   (o_buf++)			;pack giftag
	

	bal	ret_ib_draw_letter,	 draw_letter	;

	ilwr.w  ret_flag,	   (letters):mg1		;load ctrl char 1 means last letter
	iaddiu	letters,	   letters,			1
	ibeq	ret_flag,	   vi00,			set_letter

	jr	ret_ib_set_letter

;***********************************************************************************
;*                                      DRAW LETTER                                *
;***********************************************************************************			
		
draw_letter:	
	    
    lq		W2C0,	       W2C0(vi00)
    lq		W2C1,	       W2C1(vi00)
    lq		W2C2,	       W2C2(vi00)
    lq		W2C3,	       W2C3(vi00)	

;   ********* LOAD VERTECES *********

    move.w	tv1,	vf00
    move.w	tv2,	vf00
    move.w	tv3,	vf00
	
    lq.xyz	tv1,	0(letter)	;load vertex
    LQ.xyz	tv2,	1(letter)
    LQ.xyz	tv3,	2(letter)

; ********* calculate center of triangle***********
    loi		5.0e-1 	
    max.xyz	max_c,	tv1,	tv2
    max.xyz	max_c,	max_c,	tv3
    mini.xyz	min_c,	tv1,	tv2
    mini.xyz	min_c,	min_c,	tv3
    sub.xyz	center,	max_c,	min_c 


    muli.xyz	center,	center, I				
    add.xyz	center,	center, min_c	
    
    

; ********** determine if triangle is blowing on wind (mode c)*****
check_blowing:
    add.xy      b_off,  center, l_offset
    add.zw	b_off,	vf00,	vf00
    lq		tmp_math,	TEMP_MATH(vi00)	

    addx	angle,	b_off,	tmp_math
    muly	angle,	angle,	tmp_math	
;    loi		30	;= tmp_math.x
;    addi	angle,	b_off,	I    
;    loi		6.25e-2 ;= tmp_math.y
;    muli	angle,  angle, I
   
--barrier
    ANGLESINCOS angle, r_sincos
--barrier
    mulz	angle,	r_sincos,	tmp_math		
;    loi	     16			;= tmp.math.z
;    muli    angle,	r_sincos,	I		
    add.x   b_off,	b_off,		angle
    ftoi0    b_off,  b_off
    

check_blow_in:
    ilw.x      mode,		CONT1(vi00)
    iaddiu     check_mode_c,	vi00,		MODE_INTRO_C
    ibne       mode,		check_mode_c,	check_blow_away ; if not mode c, not blowing in.

    mtir       x_off,	b_off[x]
    ilw.x      tmp_math2,	TEMP_MATH2(vi00)
    iadd       x_off,	x_off, tmp_math2

;    iaddiu     x_off,	x_off,	100     ;tmp_math2.x
    isub      x_off,	f_ctl,	x_off
    
    iblez      x_off,	calc_rotation     
    
    
--barrier
; ********** determine if triangle is blowing away in wind **********    
check_blow_away:
    
    mtir	x_off,	b_off[x]
    ilw.y	tmp_math2,	TEMP_MATH2(vi00)
    iadd	x_off,		x_off,	tmp_math2
;    iaddiu	x_off,	x_off,	600		;tmp_math2.y
    isub	x_off,	f_ctl, x_off
    
; ********* if x_off <= 0 triangle is not blowing away in wind
    iblez	x_off,  skip_rotate



; ********* determine angle of rotation in wind  
calc_rotation:
	mfir.zw	        b_off,	tri_i    
	mfir.xy	 	b_off,	x_off
	itof0		b_off,	b_off
	loi		2
	muli.x		b_off,	b_off,	i
	
	loi		300.0
	minii.xy	b_off,	b_off,	I

	loi		-300.0
	maxi.xy		b_off,	b_off,	I
	move		angle,	b_off
	mulw.xy		angle,	angle, b_off		

--barrier
	ANGLESINCOS	angle,	r_sincos
--barrier
    ;	
;** ********* calculate rotation matrix
      
    mulw.y	W2C1,	W2C1,	r_sincos
    mulw.z	W2C2,	W2C2,	r_sincos
    addz.y	W2C2,	W2C2,	r_sincos
    subz.z	W2C1,	W2C1,	r_sincos

    mulx	tm0,	vf00,	vf00,
    mulx 	tm1,	vf00,	vf00,
    mr32	tm2,	vf00,	
    move	tm3,	vf00,

    addx.x	tm0,	tm0,	r_sincos
    addx.y	tm1,	tm1,	r_sincos
    addy.x	tm1,	tm1,	r_sincos
    suby.y	tm0,	tm0,	r_sincos

    mulax	acc,	tm0,	W2C0
    madday	acc,	tm1,	W2C0
    maddaz	acc,	tm2,	W2C0
    maddw	W2C0,	tm3,	W2C0

    mulax	acc,	tm0,	W2C1
    madday	acc,	tm1,	W2C1
    maddaz	acc,	tm2,	W2C1
    maddw	W2C1,	tm3,	W2C1

    mulax	acc,	tm0,	W2C2
    madday	acc,	tm1,	W2C2
    maddaz	acc,	tm2,	W2C2
    maddw	W2C2,	tm3,	W2C2

    mulax	acc,	tm0,	W2C3
    madday	acc,	tm1,	W2C3
    maddaz	acc,	tm2,	W2C3
    maddw	W2C3,	tm3,	W2C3


    ;add values into W2C3 
    mulw.y	b_off,	b_off,	r_sincos

    mulw.xy	b_off,	b_off,	tmp_math  ; temp_math replace w/loi+muli 
    loi		2
    muli.xy	W2C3,	r_sincos,i

    add.xy	W2C3,	W2C3,	b_off		;adjust x cord by x offset
    addz.xy	W2C3,	W2C3,	r_sincos	;adjust y cord by r_sin
    add.xy	W2C3,	W2C3,	center		;move back to original location

    sub.xyz	tv1,	tv1,	center	
    sub.xyz	tv2,	tv2,	center
    sub.xyz	tv3,	tv3,	center
	
   ; sqi		r_sincos,	(d_buf++)		
skip_rotate:

    LQ		color_rgb,	0(color)		;load color
    ilw.w	l_ctl,	2(letter)	;load letter ctrl (if = 1 last triangle)

  
 
	
		

;TODO calculate triangle normal
;TODO calculate lighting matrix on triangle
 




    add.xy	W2C3,	 W2C3,	l_offset
        
    mulax	acc,	W2C0,	tv1
    madday	acc,	W2C1,	tv1
    maddaz	acc,	W2C2,	tv1
    maddw	tv1,	W2C3,	tv1
    	
    mulax	acc,	 W2C0,	tv2
    madday	acc,	 W2C1,	tv2
    maddaz	acc,	 W2C2,	tv2
    maddw	tv2,	 W2C3,	tv2
	
    mulax	acc,	 W2C0,	tv3
    madday	acc,	 W2C1,	tv3
    maddaz	acc,	 W2C2,	tv3
    maddw	tv3,	 W2C3,	tv3


    ftoi0	color_rgb,	 color_rgb
	
	bal	ret_draw_triangle,	 draw_triangle	

	iaddiu	letter, letter, 1		;increment 
	ibeq	l_ctl,	vi00,	draw_letter	;draw next triangle in letter   
	
	b	finish_draw_letter
finish_draw_letter:
	isw.x	nloop,	INTRO_O_BUFFER(vi00)		;
	SQI	gt_eop,	(o_buf++)
	
	iaddiu	o_buf,	vi00,	INTRO_O_BUFFER	;
	xgkick	o_buf,


	jr ret_ib_draw_letter




; ********************************************************************************
; *                                DRAW TRIANGLE                                 *
; ********************************************************************************
draw_triangle:
	
	mulax	acc,	c2s0,	tv1
	madday	acc,	c2s1,	tv1
	maddaz	acc,	c2s2,	tv1
	maddw	tv1,	c2s3,	tv1

	div	q,	vf00[w],	tv1[w]	
	mul	tv1,	tv1,	q



draw_triangle_y:
	mulax	acc,	c2s0,	tv2
	madday	acc,	c2s1,	tv2
	maddaz	acc,	c2s2,	tv2
	maddw	tv2,	c2s3,	tv2
	div	q,	vf00[w],	tv2[w]	
	mul	tv2,	tv2,	q

draw_triangle_z:
	mulax	acc,	c2s0,	tv3
	madday	acc,	c2s1,	tv3
	maddaz	acc,	c2s2,	tv3
	maddw	tv3,	c2s3,	tv3
	div	q,	vf00[w],	tv3[w]	
	mul	tv3,	tv3,	q
	
	LQ	gt_eop,	GT_EOP(vi00)		;
	
	ftoi4	tv1,	tv1
	ftoi4	tv2,	tv2
	ftoi4	tv3,	tv3
	
	iaddiu	nloop,	nloop,	1	;increment # of triangles drawn this giftag
	iaddiu	tri_i,	tri_i,	1	;increment total # of triangles drawn

	sqi	color_rgb,	(o_buf++)	;pack triangle
	sqi	tv1,	(o_buf++)
	sqi	tv2,	(o_buf++)
	sqi	tv3,	(o_buf++)

	
	jr ret_draw_triangle


;function unpack_package_8xy
;unpacks a set of 5 1 qword compressed vertex packages to 40 qwords in vu mem
; x1.x2x3x4, y1.y2y3y4, x5.x6x7x8, y5.y6y7y8
;
; required variables:
; vi(unpack_buffer)  :  pointer in vu mem to unpack packages
; vi(package_pointer):  pointer in vu mem to package. 
; vi(ret_unpack)     :  address to return to when unpacking completes

unpack_package:

;	iaddiu		unpack_buffer,	   vi00,	INTRO_UNPACK_BUFFER
;	iaddiu		package_pointer,   vi00,	H_CROSS

	lq		packet,		   0(package_pointer):dg_2
	ftoi0		packet,		   packet
	mtir		packet_test,	   packet[x]
	ibltz		packet_test,	   unpack_set_packet_size

	iaddiu		total_unpacked,	   vi00,	40
	b		unpack_load_packet

unpack_set_packet_size:

	ilwr.w		total_unpacked,	  (package_pointer)
	iaddiu		package_pointer,  package_pointer,	1
	b		unpack_load_packet	
	
unpack_load_packet:
	lqi		packet,		(package_pointer++):dg_2
	iaddiu		unpack_count,	vi00,	8
	ibeq		total_unpacked,	vi00,	finish_unpack
;	sqi		packet,	(unpack_buffer++):dg_2		;debugging line

unpack_loop:	
	ftoi0		packet_x,	packet			 ;packet_x = x1,y1,x5,y5
	itof0		packet_x,	packet_x		 ;packet_x = x1.0,y1.0,x5.0,y5.0
	sub		packet,		packet,		packet_x ; packet = 0.x2x3,....

	loi		0.1
	muli		packet_x,	packet_x,	I		 ;x.x,y.y,x.x,y.y
	mulx.xyzw	unpacked1,	vf00,		vf00		 ;initalize unpacked1
	move.xy		unpacked1,	packet_x			 ;complete unpacking 1st vert
	mulx.xyzw	unpacked2,	vf00,		vf00		 ;initalize unpacked2
	addz.x		unpacked2,	unpacked2,	packet_x	 ;complete unpacking 2nd vert
	addw.y		unpacked2,	unpacked2,	packet_x
	sq		unpacked2,	4(unpack_buffer):dg_1		 ;write to unpack buffer
	sqi		unpacked1,	(unpack_buffer++):dg_1	
	
	isubiu		total_unpacked,	total_unpacked,	2			
	isubiu		unpack_count,	unpack_count,	2

	ibeq		unpack_count,	vi00,		unpack_step_unpack_buffer
				
	loi		100.0
	muli		packet,	packet, I		;packet =	xx.xx...
	
	b		unpack_loop	

unpack_step_unpack_buffer:
	iaddiu		unpack_buffer,	unpack_buffer,	4
	b		unpack_load_packet	
	

finish_unpack:
	iaddiu		u_flg,		vi00,		1
	isubiu		unpack_buffer,	unpack_buffer,	1
	isw.w		u_flg, 0(unpack_buffer)	

	jr		ret_unpack



;************************************************************************************
;*                                  INTRO MODE A                                    *
;************************************************************************************
intro_a:
	ilw.y	f_ctl,	CONT1(vi00)	;load frame control
	iadd	tri_i,	vi00,		vi00				

	iaddiu	rhombus_ptr,	vi00,	RHOMBUS
	
	lq	color,	RED(vi00)
	ftoi0	color_rgb,	color


	iaddiu	nloop,	vi00,	vi00
	iaddiu	o_buf,	vi00,	INTRO_O_BUFFER
	lq	gt_tri,		GT_TRIANGLE(vi00)
	sqi	gt_tri,	 (o_buf++)



	lq	c2s0,	C2S(vi00)	;
	lq	c2s1,	C2S+1(vi00)	;
	lq	c2s2,	C2S+2(vi00)	;
	lq	c2s3,	C2S+3(vi00)	
	lq	tv1,	0(rhombus_ptr)
	lq	tv2,	1(rhombus_ptr)
	lq	tv3,	2(rhombus_ptr)
	bal	ret_intro_a_spin,	intro_a_spin
	
	bal	ret_draw_triangle,	draw_triangle
--barrier	
	lq	tv1,	1(rhombus_ptr)
	lq	tv2,	2(rhombus_ptr)
	lq	tv3,	3(rhombus_ptr)
--barrier

	bal	ret_intro_a_spin,	intro_a_spin

	bal	ret_draw_triangle,	draw_triangle

	lq	gt_eop,	GT_EOP(vi00)
	sqi	gt_eop,	(o_buf++):dga	

	iaddiu	o_buf,	vi00,	INTRO_O_BUFFER
	iswr.x	nloop,	(o_buf):dga
--barrier
	xgkick	o_buf,

	isubiu	f_ctl,	f_ctl, 1
	isw.y	f_ctl,	CONT1(vi00)


	ibeq	f_ctl,	vi00,	setup_intro_b
						
	b	exit		

setup_intro_b
	iaddiu	mode,	vi00,	MODE_INTRO_B
	isw.x	mode,  CONT1(vi00)
	b	exit

; ***********************************************************************
; *                           INTRO A SPIN                              *
; ***********************************************************************


intro_a_spin:

    lq		W2C0,	W2C0(vi00)
    lq		W2C1,	W2C1(vi00)
    lq		W2C2,	W2C2(vi00)
    lq		W2C3,	W2C3(vi00)

; ************** find center *************
    loi		 5.0e-1
    max.xyz	max_c,	tv1,	tv2
    max.xyz	max_c,	max_c,	tv3
    mini.xyz	min_c,	tv1,	tv2
    mini.xyz	min_c,	min_c,	tv3
    sub.xyz	center,	max_c,	min_c 


    muli.xyz	center,	center, I				
    add.xyz	center,	center, min_c	
    isubiu	tmp_offset,	f_ctl,	50
    iblez	tmp_offset,	skip_spin

    
    loi		6.25e-2

    mfir.xyzw	xyz_offset,	tmp_offset
    itof0.xyzw	xyz_offset,	xyz_offset

    move	angle,		xyz_offset		
  
    
    max  	angle,	angle,	vf00
    muli.xy	angle,	angle,	I
    loi		1.25e-1
    muli.zw	angle,	angle,	I
--barrier
    ANGLESINCOS	angle,	r_sincos
--barrier
      
    mulw.y	W2C1,	W2C1,	r_sincos
    mulw.z	W2C2,	W2C2,	r_sincos
    addz.y	W2C2,	W2C2,	r_sincos
    subz.z	W2C1,	W2C1,	r_sincos

    mulx	tm0,	vf00,	vf00,
    mulx 	tm1,	vf00,	vf00,
    mr32	tm2,	vf00,	
    move	tm3,	vf00,

    addx.x	tm0,	tm0,	r_sincos
    addx.y	tm1,	tm1,	r_sincos
    addy.y	tm1,	tm1,	r_sincos
    suby.x	tm0,	tm0,	r_sincos

    mulax	acc,	tm0,	W2C0
    madday	acc,	tm1,	W2C0
    maddaz	acc,	tm2,	W2C0
    maddw	W2C0,	tm3,	W2C0

    mulax	acc,	tm0,	W2C1
    madday	acc,	tm1,	W2C1
    maddaz	acc,	tm2,	W2C1
    maddw	W2C1,	tm3,	W2C1

    mulax	acc,	tm0,	W2C2
    madday	acc,	tm1,	W2C2
    maddaz	acc,	tm2,	W2C2
    maddw	W2C2,	tm3,	W2C2

    mulax	acc,	tm0,	W2C3
    madday	acc,	tm1,	W2C3
    maddaz	acc,	tm2,	W2C3
    maddw	W2C3,	tm3,	W2C3

    add.xyz	xyz_offset,	xyz_offset,	r_sincos
    add.xy	W2C3,	W2C3,	center
    loi		-1
    muli.y	xyz_offset,	xyz_offset,	I

    ibne	nloop,	vi00,	skip_negative
    
    muli	xyz_offset,	xyz_offset,	I
skip_negative:

    add.xyz	W2C3,	W2C3,	xyz_offset
    
    sub.xy	tv1,	tv1,	center
    sub.xy	tv2,	tv2,	center
    sub.xy	tv3,	tv3,	center

; ******** spin/move triangles
        
    mulax	acc,	W2C0,	tv1
    madday	acc,	W2C1,	tv1
    maddaz	acc,	W2C2,	tv1
    maddw	tv1,	W2C3,	tv1
    	
    mulax	acc,	 W2C0,	tv2
    madday	acc,	 W2C1,	tv2
    maddaz	acc,	 W2C2,	tv2
    maddw	tv2,	 W2C3,	tv2
	
    mulax	acc,	 W2C0,	tv3
    madday	acc,	 W2C1,	tv3
    maddaz	acc,	 W2C2,	tv3
    maddw	tv3,	 W2C3,	tv3


skip_spin:
    jr		ret_intro_a_spin
	
exit:


--exit
--endexit
END
