
; winds.vcl
; Copyright (C) 2003 Martin Piper
;

.init_vf_all	;
.init_vi_all	;
.syntax new

.include "winds.i"
.include "vcl_sml.i"

--enter
--endenter

; *********************************************************************
; **************************** MODE LOOP ******************************
; *********************************************************************
mode_loop:
   iaddiu	debug,		vi00,	MAIN_D_BUFFER
   ilw.x	mode,		CONT1(vi00)
   
; ******************  CHECK MAIN DEMO  ************
; flag grass etc blowing in wind.

   iaddiu	mode_main,	vi00,		MODE_MAIN
   ibeq		mode,		mode_main,	main

; ******************  CHECK SETUP MAIN ************
; set flag points etc

   iaddiu       mode_setup_main,vi00,		MODE_SETUP_MAIN
   ibeq		mode,		mode_setup_main,	setup_main

; *************** CHECK INTRO MODE A *************
;2 triangles flying/spinning toward center of screen.  End in flash?

   iaddiu	mode_intro_a,	vi00,		MODE_INTRO_A
   ibeq		mode,		mode_intro_a,	intro_a

; *************** CHECK INTRO MODE B *************
; RHOMBUS on screen, RHOMBUS STUDIOS PRESENTS...

   iaddiu	mode_intro_b,	vi00,		MODE_INTRO_B
   ibeq		mode,		mode_intro_b,	intro_b

;**************** CHECK INTRO MODE C *************
; THE WINDS...
   iaddiu	mode_intro_c,	vi00,		MODE_INTRO_C
   ibeq		mode,		mode_intro_c,	intro_c

   b exit 


.include "intro_winds.i"


setup_main:
    bal    ret_setup_w2c,	setup_w2c
    bal	   ret_setup_flag,	setup_flag
    bal	   ret_setup_flag_data,	setup_flag_data


    b      exit


;***************************************************************
;                           SETUP FLAG
;***************************************************************
setup_flag:					; SETUP FLAG POINTS
   iaddiu	pt_flag_verts,	vi00,	FLAG_VERTS
   lq		flag_setup1,	FLAG_SETUP1(vi00)	
   ilw.x	flag_height_h,	FLAG_SETUP2(vi00)
   ilw.y	flag_height,	FLAG_SETUP2(vi00)
   ilw.z	flag_width,	FLAG_SETUP2(vi00)
   iadd		vert_counter_h,	vi00,	vi00
   iadd		vert_counter_w,	vi00,	vi00

   ;set point for top of rope
   mulx.xyzw	vert,		vf00,		vf00
   loi		-2.0		
   addi.y	vert,		vert,	I

   sq		vert,		NUM_FLAG_VERTS(pt_flag_verts):dga 
   sqi		vert,		(pt_flag_verts++):dga
 
   move		vert,		vf00,

   subi.x	vert,		vert,	I
   addy.y	vert,		vert,	flag_setup1			;1st vertex 0.0,sin 30,0.0,1
   loi		15.0  
   addi.w	vert,		vert,	I   
setup_flag_short:
   sq		vert,		NUM_FLAG_VERTS(pt_flag_verts):dga	;store vertex in last vert
   sqi		vert,		(pt_flag_verts++):dga			
   addw.y	vert,		vert,	flag_setup1			;add 2 sin 30 to y
   iaddiu	vert_counter_h,	vert_counter_h,  1
   ibne		vert_counter_h,	flag_height_h, setup_flag_short		; if not 1/2 height do again

   ibeq		vert_counter_w,	flag_width,    finish_flag_setup	;if we are done with flag skip to end

   add.xz	vert,		vert,	       flag_setup1		;add 0.5 to x
   move.y	vert,		vf00					;reset y to 0.0

setup_flag_long:
   sq		vert,		NUM_FLAG_VERTS(pt_flag_verts):dgb	
   sqi		vert,		(pt_flag_verts++):dgb			;store vertex
   addw.y	vert,		vert,		 flag_setup1		;add 2 sin 30 to y
   iaddiu	vert_counter_h,	vert_counter_h,  1			; add 1 to counter
   ibne		vert_counter_h,	flag_height,	 setup_flag_long	; rerun flag


   add.x	vert,		vert,		 flag_setup1
   move.y	vert,		flag_setup1
   iaddiu	vert_counter_w,	vert_counter_w,	 1
   iadd		vert_counter_h,	vi00,		 vi00
   b		setup_flag_short  

finish_flag_setup:

   iaddiu	rope_count,	vi00,	8	
   loi		2.5
   addi.x	vert,		vf00,	I ;flag_setup1

setup_flag_rope:
   addw.y	vert,		vert,		flag_setup1
   sq		vert,		NUM_FLAG_VERTS(pt_flag_verts):dgc
   sqi		vert,		(pt_flag_verts++):dgc
   isubiu	rope_count,	rope_count,	1
   ibne		rope_count,	vi00,		setup_flag_rope

   addy.y	vert,		vert,		flag_setup1
   mulx.xw	vert,		vf00,		vf00
   sq		vert,		NUM_FLAG_VERTS(pt_flag_verts):dgd
   sqi		vert,		(pt_flag_verts++)


   iaddiu	mode,		vi00,	MODE_MAIN
   isw.x	mode,		CONT1(vi00)
   jr		ret_setup_flag


;*********************************************************
;              SETUP LOCAL TO WORLD  
;*********************************************************
setup_w2c:
   lq		cont2,		CONT2(vi00)

   lq		w2ca0,		W2CA0(vi00)	
   lq		w2ca1,		W2CA1(vi00)
   lq		w2ca2,		W2CA2(vi00)
   lq		w2ca3,		W2CA3(vi00)

   lq		w2cb0,		W2CB0(vi00)
   lq		w2cb1,		W2CB1(vi00)
   lq		w2cb2,		W2CB2(vi00)
   lq		w2cb3,		W2CB3(vi00)

   ANGLESINCOS	cont2,		w2c_r_sincos

   addw.x	w2cb0,		vf00,	w2c_r_sincos   //rotate around y axis
   addz.z	w2cb0,		vf00,	w2c_r_sincos
   subz.x	w2cb2,		vf00,	w2c_r_sincos
   addw.z	w2cb2,		vf00,	w2c_r_sincos

   mulax	acc,		w2cb0,	w2ca0
   madday	acc,		w2cb1,	w2ca0
   maddaz	acc,		w2cb2,	w2ca0
   maddw.xyz	w2ca0,		w2cb3,	w2ca0
   mulax	acc,		w2cb0,	w2ca1
   madday	acc,		w2cb1,	w2ca1
   maddaz	acc,		w2cb2,	w2ca1
   maddw.xyz	w2ca1,		w2cb3,	w2ca1
   mulax	acc,		w2cb0,	w2ca2
   madday	acc,		w2cb1,	w2ca2
   maddaz	acc,		w2cb2,	w2ca2
   maddw.xyz	w2ca2,		w2cb3,	w2ca2
   mulax	acc,		w2cb0,	w2ca3
   madday	acc,		w2cb1,	w2ca3
   maddaz	acc,		w2cb2,	w2ca3
   maddw.xyz	w2ca3,		w2cb3,	w2ca3 

   addy.z	w2ca3,		w2ca3,	cont2
   
   addy.y	w2cb1,		vf00,	w2c_r_sincos   //rotate around x axis
   subx.z	w2cb1,		vf00,	w2c_r_sincos
   addx.y	w2cb2,		vf00,	w2c_r_sincos
   addy.z	w2cb2,		vf00,	w2c_r_sincos

   mulax	acc,		w2cb0,	w2ca0
   madday	acc,		w2cb1,	w2ca0
   maddaz	acc,		w2cb2,	w2ca0
   maddw	w2ca0,		w2cb3,	w2ca0
   mulax	acc,		w2cb0,	w2ca1
   madday	acc,		w2cb1,	w2ca1
   maddaz	acc,		w2cb2,	w2ca1
   maddw	w2ca1,		w2cb3,	w2ca1
   mulax	acc,		w2cb0,	w2ca2
   madday	acc,		w2cb1,	w2ca2
   maddaz	acc,		w2cb2,	w2ca2
   maddw	w2ca2,		w2cb3,	w2ca2
   mulax	acc,		w2cb0,	w2ca3
   madday	acc,		w2cb1,	w2ca3
   maddaz	acc,		w2cb2,	w2ca3
   maddw	w2ca3,		w2cb3,	w2ca3 


   sq		w2ca0,		W2C0(vi00)
   sq		w2ca1,		W2C1(vi00)
   sq		w2ca2,		W2C2(vi00)
   sq		w2ca3,		W2C3(vi00)

   jr	ret_setup_w2c

;*************************************************************
;                  SETUP FLAG TRIANGLE DATA      
;*************************************************************

setup_flag_data:

   iaddiu	sf_tri_pointer,	vi00,	FLAG_TRIANGLE_DATA
   iaddiu	sf_base_vert,	vi00,	1
   iaddiu	sf_rot_dir,	vi00,	0
   iaddiu	sf_tri_counter,	vi00,	21
   
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip
   iaddiu	sf_base_vert,	vi00,	1
   iaddiu	sf_tri_counter,	vi00,	21

   bal		ret_setup_flag_data_strip,	setup_flag_data_strip


   iaddiu	sf_base_vert,	vi00,	2;
   iaddiu	sf_tri_counter,	vi00,	21
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip
 
   iaddiu	sf_base_vert,	vi00,	2;
   iaddiu	sf_tri_counter,	vi00,	21;
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip


   iaddiu	sf_base_vert,	vi00,	3;
   iaddiu	sf_tri_counter,	vi00,	21
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip
   

   iaddiu	sf_base_vert,	vi00,	3;
   iaddiu	sf_tri_counter,	vi00,	21
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip

   iaddiu	sf_base_vert,	vi00,	4;
   iaddiu	sf_tri_counter,	vi00,	21
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip
   

   iaddiu	sf_base_vert,	vi00,	4;
   iaddiu	sf_tri_counter,	vi00,	21;
   bal		ret_setup_flag_data_strip,	setup_flag_data_strip


    jr		ret_setup_flag_data
   

setup_flag_data_strip:
   ibne		sf_rot_dir,	vi00,	set_flag_data_strip1

   iswr.x	sf_base_vert,	(sf_tri_pointer)
   iaddiu	sf_temp,	sf_base_vert,	9	
   iswr.z	sf_temp,	(sf_tri_pointer)
   iaddiu	sf_base_vert,	sf_base_vert,	4
   iswr.y	sf_base_vert,	(sf_tri_pointer)
   iswr.w	sf_rot_dir,	(sf_tri_pointer)
   iaddiu	sf_rot_dir,	vi00,	1 
   isubiu	sf_tri_counter,	sf_tri_counter,	1
   iaddiu	sf_tri_pointer, sf_tri_pointer, 1
   ibne		sf_tri_counter,	vi00,	setup_flag_data_strip
   

   jr	ret_setup_flag_data_strip	

set_flag_data_strip1:

   iswr.x	sf_base_vert,	(sf_tri_pointer)
   iaddiu	sf_temp,	sf_base_vert,	9	
   iswr.y	sf_temp,	(sf_tri_pointer)
   iaddiu	sf_base_vert,	sf_base_vert,	5
   iswr.z	sf_base_vert,	(sf_tri_pointer)
   iswr.w	sf_rot_dir,	(sf_tri_pointer)
   iaddiu	sf_rot_dir,	vi00,	0 
   isubiu	sf_tri_counter,	sf_tri_counter,	1
   iaddiu	sf_tri_pointer,	sf_tri_pointer, 1
   ibne		sf_tri_counter,	vi00,	setup_flag_data_strip
      
   jr	ret_setup_flag_data_strip	






;--------------------------------------------------------------------------------
;------------------------------------MAIN DEMO-----------------------------------
;--------------------------------------------------------------------------------
main:

;	bal	ret_setup_w2c,	setup_w2c
	;check input here
	bal    ret_clear_previous_flag_data, clear_previous_flag_data
	bal    ret_check_verts_for_exposure, check_verts_for_exposure
	bal    ret_calc_wind_force_on_triangle,	calc_wind_force_on_triangle
;	bal    ret_do_vertlet_integration,   do_vertlet_integration
:	b    do_vert_constraints
ret_do_vert_constraints:

skip_physics:
	bal    ret_main_draw_flag,	main_draw_flag
	bal    ret_main_draw_rope,	main_draw_rope
;	bal    ret_main_draw_flagpole,	main_draw_flagpole

	b	exit


main_draw_flag:

   iaddiu	flag_strip_i,	vi00,	vi00;

set_flag_strip:
   ilw.x	vert_index,	FLAG_STRIPS(flag_strip_i)
   ilw.y	vert_counter,	FLAG_STRIPS(flag_strip_i)
   ilw.z	vert_color,	FLAG_STRIPS(flag_strip_i)
   ilw.w	calc_mode,	FLAG_STRIPS(flag_strip_i)
   iaddiu	o_buf,		vi00,	MAIN_O_BUFFER
      
   
   bal		ret_draw_flag_strip,	draw_flag_strip

   iaddiu	flag_strip_i,	flag_strip_i,	1
   iaddiu	num_flag_strips,vi00,		NUM_FLAG_STRIPS
   ibne		flag_strip_i,   num_flag_strips,	set_flag_strip
   
   jr		ret_main_draw_flag


draw_flag_strip:
   lq		w2c0,		W2C0(vi00)
   lq		w2c1,		W2C1(vi00)
   lq		w2c2,		W2C2(vi00)
   lq		w2c3,		W2C3(vi00)

   lq		c2s0,		C2S(vi00)
   lq		c2s1,		C2S+1(vi00)
   lq		c2s2,		C2S+2(vi00)
   lq		c2s3,		C2S+3(vi00)

   lq		gt_tri_s,	GT_TRIANGLE_STRIP(vi00)
   isw.x	vert_counter,	(o_buf):dg_dfs1
   sqi.yzw	gt_tri_s,	(o_buf++):dg_dfs1
   
   
draw_flag_strip_pack_vertex:	
   lq           flag_vert,	FLAG_VERTS(vert_index)
   lq		color,		COLORS(vert_color)

   move.w	flag_vert,	vf00
   mulax	acc,		w2c0,		flag_vert
   madday	acc,		w2c1,		flag_vert
   maddaz	acc,		w2c2,		flag_vert
   maddw	flag_vert,	w2c3,		flag_vert   


; in here calculate lighting for vertex
; in here calculate color for vertex

   
   mulax	acc,		c2s0,		flag_vert
   madday	acc,		c2s1,		flag_vert
   maddaz	acc,		c2s2,		flag_vert
   maddw	flag_vert,	c2s3,		flag_vert
   
   div		q,		vf00[w],	flag_vert[w]


   ftoi0	color,	  color,
   sqi		color,	  (o_buf++)
   
   mul		flag_vert,	flag_vert,	q
   
   ftoi4	flag_vert,	flag_vert

   sqi		flag_vert,	(o_buf++)

   isubiu	vert_counter,	vert_counter,	1

   ibeq		vert_counter,	vi00,	draw_flag_strip_kick

   ibeq		calc_mode,	vi00,	draw_flag_strip_calc_0

draw_flag_strip_calc_1:
   iaddiu	vert_index,	vert_index,	5	
   iaddiu	calc_mode,	vi00,		vi00
   b		draw_flag_strip_pack_vertex

draw_flag_strip_calc_0:
   iaddiu	vert_index,	vert_index,	4
   iaddiu	calc_mode,	vi00,		1
   b		draw_flag_strip_pack_vertex

draw_flag_strip_kick:
   lq		gt_eop,		GT_EOP(vi00)
   sq		gt_eop,		0(o_buf)


--barrier   
   iaddiu	o_buf,		vi00,	MAIN_O_BUFFER
   xgkick	o_buf,

   
   jr		ret_draw_flag_strip		
   


;*************************************************************************************
;*					DRAW ROPE                                    *
;*************************************************************************************

main_draw_rope:
    iaddiu	rope_strip_i,	vi00,	vi00
       
set_rope_strip:
    iaddiu	rope_vert_counter,	vi00,	vi00
    ilw.x	vert_i,			FLAG_ROPE_SECTIONS(rope_strip_i)
    ilw.y	last_vert,		FLAG_ROPE_SECTIONS(rope_strip_i)
    ilw.z	strip_mode,		FLAG_ROPE_SECTIONS(rope_strip_i)
    iaddiu	o_buf,			vi00,	MAIN_O_BUFFER

    bal		ret_draw_rope_strip,	draw_rope_strip

    iaddiu	rope_strip_i,	rope_strip_i,	1
    iaddiu	num_rope_strips,	vi00,	NUM_ROPE_STRIPS
    ibne	rope_strip_i,	num_rope_strips,	set_rope_strip

    jr		ret_main_draw_rope

draw_rope_strip:
    lq		w2c0,	W2C0(vi00)
    lq		w2c1,	W2C1(vi00)
    lq		w2c2,	W2C2(vi00)
    lq		w2c3,	W2C3(vi00)

    lq		c2s0,	C2S(vi00)
    lq		c2s1,	C2S+1(vi00)
    lq		c2s2,	C2S+2(vi00)
    lq		c2s3,	C2S+3(vi00)
    	
    lq		gt_line_strip,		GT_LINE_STRIP(vi00)
    sqi		gt_line_strip,		(o_buf++)

draw_rope_strip_pack_vertex:

   lq           rope_vert,	FLAG_VERTS(vert_i)
   move.w	rope_vert,	vf00	
   lq		color,		BROWN(vi00)

   mulax	acc,		w2c0,		rope_vert
   madday	acc,		w2c1,		rope_vert
   maddaz	acc,		w2c2,		rope_vert
   maddw	rope_vert,	w2c3,		rope_vert   
   


; in here calculate lighting for vertex
; in here calculate color for vertex

   ftoi0	color,	  color,
   sqi		color,	  (o_buf++)
   
   
   mulax	acc,		c2s0,		rope_vert
   madday	acc,		c2s1,		rope_vert
   maddaz	acc,		c2s2,		rope_vert
   maddw	rope_vert,	c2s3,		rope_vert
   div		q,		vf00[w],	rope_vert[w]
   mul		rope_vert,	rope_vert,	q
   
   ftoi4	rope_vert,	rope_vert

   sqi		rope_vert,	(o_buf++)

   iaddiu	rope_vert_counter,	rope_vert_counter,	1

   ibeq		vert_i,		last_vert,	draw_rope_strip_kick

   ibne		strip_mode,	vi00,		strip_mode_1

   iaddiu	vert_i,		vert_i,		1

   b		draw_rope_strip_pack_vertex
strip_mode_1:
   iadd		vert_i,		vi00,		last_vert

   b		draw_rope_strip_pack_vertex


draw_rope_strip_kick:
   lq		gt_eop,		GT_EOP(vi00)
   sqi		gt_eop,		(o_buf++)

   iaddiu	o_buf,		vi00,		MAIN_O_BUFFER
   isw.x	rope_vert_counter,	(o_buf)

   xgkick	o_buf
   jr		ret_draw_rope_strip

; *******************************************************************
;                      CLEAR_PREVIOUS_FLAG_DATA
; *******************************************************************


clear_previous_flag_data:
   iaddiu	cpfd_vert_counter,	vi00,	NUM_FLAG_VERTS
   mulx.xyzw	clear_previous,		vf00,	vf00

cpfd_clear_loop:                   
   isubiu	cpfd_vert_counter,	cpfd_vert_counter,	1
   sq		clear_previous,		FLAG_VERTS_CALCS(cpfd_vert_counter)
   ibne		cpfd_vert_counter,	vi00,		cpfd_clear_loop

   jr	ret_clear_previous_flag_data	


; ********************************************************************
;                      CHECK_VERTS_FOR_EXPOSURE
; ********************************************************************
check_verts_for_exposure:
   iaddiu	cvfe_vert_counter,	vi00,	NUM_FLAG_VERTS
   lq		exposure_source,	WIND(vi00)
   loi		-1.0
   muli.xyz	exposure_source,	exposure_source,	I

check_verts_for_exposure_loop:
   isubiu	cvfe_vert_counter,	cvfe_vert_counter,	1
   lq		exposure_target,	FLAG_VERTS(cvfe_vert_counter)

   bal		ret_check_vert_for_exposure,	check_vert_for_exposure
   isw.w	ret_exposure,		FLAG_VERTS_CALCS(cvfe_vert_counter)
   ibne		cvfe_vert_counter,	vi00,		check_verts_for_exposure_loop
   
   jr		ret_check_verts_for_exposure:
   



; *********************************************************************
; *		     CHECK VERT FOR WIND EXPOSURE                     *
; *********************************************************************
; required register vars....
;  vf  exposure_source -normalized vector to check exposure along   
;  vf  exposure_target -point to check line of sight for
;  vi  ret_check_vert_for_exposure - where to return to
;  vi  exposure_mode - what mode to check for
;                      0-vi ret_exposure set to 0 if obstructed
;		       1-vi ret_exposure set to # of obstructions
; only 0 implemented due to time-flag not translucent

check_vert_for_exposure:
      iaddiu	tri_i,		vi00,		NUM_FLAG_TRIANGLES
check_triangle_for_obstruction:
      ibne	tri_i,		vi00,	check_triangle_for_obstruction_a
      iaddiu	ret_exposure,	vi00,	1
      jr	ret_check_vert_for_exposure


check_triangle_for_obstruction_a:


;load triangle verts
      ilw.x	vt_i,		FLAG_TRIANGLE_DATA+1(tri_i)
      lq	vt1,		FLAG_VERTS(vt_i)
      ilw.y	vt_i,		FLAG_TRIANGLE_DATA+1(tri_i)
      lq	vt2,		FLAG_VERTS(vt_i)
      ilw.z	vt_i,		FLAG_TRIANGLE_DATA+1(tri_i)
      lq	vt3,		FLAG_VERTS(vt_i)
      isubiu	tri_i,		tri_i,		1

;check if exposure_target = vt1, vt2 or vt3
      iaddiu	check_mask, vi00,    0x000E
      sub.xyz	tmp,	  vt1,	 exposure_target
      fmand	check_result,	 check_mask
      ibeq	check_result,	 check_mask, check_triangle_for_obstruction
check_vt2_eq_ex_t:     
      sub.xyz	tmp,	  vt2,	 exposure_target
      fmand	check_result,	 check_mask
      ibeq	check_result,	 check_mask, check_triangle_for_obstruction
check_vt3_eq_ex_t:     
      sub.xyz	tmp,	  vt3,	 exposure_target
      fmand	check_result,	 check_mask
      ibeq	check_result,	 check_mask, check_triangle_for_obstruction
     
calc_tri_norm:

;calculate triangle normal
      sub.xyz	vector1,	vt2,	vt1
      sub.xyz	vector2,	vt1,	vt3

      opmula.xyz	acc,		vector1,	vector2
      opmsub.xyz	tri_normal,	vector2,	vector1

      mul.xyz		dist_to_0,	vt1,		tri_normal
      addy.x		dist_to_0,	dist_to_0,	dist_to_0
      addz.x		dist_to_0,	dist_to_0,	dist_to_0
      mulx.w		tri_normal,	vf00,		dist_to_0

;calculate dot_product tri_n.es
      mul.xyz	       tn_dot_es,	tri_normal,      exposure_source
      addy.x	       tn_dot_es,	tn_dot_es,	 tn_dot_es
      addz.x	       tn_dot_es,	tn_dot_es,	 tn_dot_es


;check if ||
check_for_par:
      iaddiu		check_mask,	vi00,		0x0008		; x=0		
      fmand		check_result,	check_mask
      ibeq		check_result,	check_mask,	check_triangle_for_obstruction
     
;calculate_dot_product tri_n.et
      mul.xyz	       tn_dot_et,	tri_normal,	exposure_target
      addy.x	       tn_dot_et,	tn_dot_et,	tn_dot_et
      addz.x	       tn_dot_et,	tn_dot_et,	tn_dot_et

check_on_plane:
      sub.x	       d_m_tn_dot_et,	dist_to_0,	tn_dot_et
      fmand	       check_result,	check_mask
      ibeq	       check_result,	check_mask,	check_triangle_for_obstruction

check_plane_behind_et:
      div	       q,		d_m_tn_dot_et[x],	tn_dot_es[x]	
      addq.x	       q_result,	vf00,			q
      iaddiu	       check_mask,	vi00,			0x0080
      fmand	       check_result,	check_mask
      ibeq	       check_result,	check_mask,	check_triangle_for_obstruction

calc_point_on_plane:
      mulx.xyz	       collision_pt,	exposure_source,	q_result
      add.xyz	       collision_pt,	collision_pt,		exposure_target

find_distance_to_points:
      sub.xyz	       vt1,	collision_pt,	vt1
      mul.xyz	       vt1,	vt1,		vt1
      addy.x	       vt1,	vt1,		vt1
      addz.x	       vt1,	vt1,		vt1
      loi	       1.0
      subi.x	       vt1,	vt1,		I
      fmand	       check_result,	check_mask
      ibeq	       check_result,	check_mask,	check_triangle_for_obstruction
      
      sub.xyz	       vt1,	collision_pt,	vt1
      mul.xyz	       vt1,	vt1,		vt1
      addy.x	       vt1,	vt1,		vt1
      addz.x	       vt1,	vt1,		vt1
      loi	       1.0
      subi.x	       vt1,	vt1,		I
      fmand	       check_result,	check_mask
      ibeq	       check_result,	check_mask,	check_triangle_for_obstruction


      sub.xyz	       vt1,	collision_pt,	vt1
      mul.xyz	       vt1,	vt1,		vt1
      addy.x	       vt1,	vt1,		vt1
      addz.x	       vt1,	vt1,		vt1
      loi	       1.0
      subi.x	       vt1,	vt1,		I
      fmand	       check_result,	check_mask
      ibeq	       check_result,	check_mask,	check_triangle_for_obstruction


      iaddiu	       ret_exposure,	vi00,		0
      jr	       ret_check_vert_for_exposure   
   


; *********************************************************************
; *		     CALCULATE WIND FORCE ON TRIANGLE                 *
; *********************************************************************
calc_wind_force_on_triangle:
    iaddiu	cwfot_triangle_counter,		vi00,	NUM_FLAG_TRIANGLES
    lq		cwfot_wind,		WIND(vi00)
 
calc_wind_force_on_triangle_loop:
    isubiu	cwfot_triangle_counter,	cwfot_triangle_counter,	1
    ibltz	cwfot_triangle_counter,	break_cwfot_loop

    ilw.x	vt1_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)   	
    ilw.y	vt2_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)
    ilw.z	vt3_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)

    lq		cwfot_vt1,	FLAG_VERTS(vt1_ptr)
    lq		cwfot_vt1_calc,	FLAG_VERTS_CALCS(vt1_ptr)
    lq		cwfot_vt2,	FLAG_VERTS(vt2_ptr)
    lq		cwfot_vt2_calc,	FLAG_VERTS_CALCS(vt2_ptr)
    lq		cwfot_vt3,	FLAG_VERTS(vt3_ptr)
    lq		cwfot_vt3_calc,	FLAG_VERTS_CALCS(vt3_ptr)

    itof0.w	cwfot_vt1,	cwfot_vt1_calc	
    itof0.w	cwfot_vt2,	cwfot_vt2_calc
    itof0.w	cwfot_vt3,	cwfot_vt3_calc


    add.w	accum_wind,	cwfot_vt1,	cwfot_vt2
    add.w	accum_wind,	accum_wind,	cwfot_vt3

    iaddiu	check_mask,	vi00,	0x0001
    fmand	check_result,	check_mask
    ibeq	check_result,	check_mask,	calc_wind_force_on_triangle_loop

        
;calculate triangle normal
      sub.xyz	vector1,	cwfot_vt2,	cwfot_vt1
      sub.xyz	vector2,	cwfot_vt3,	cwfot_vt1

      opmula.xyz	acc,		vector1,	vector2
      opmsub.xyz	cwfot_tn,	vector2,	vector1
      
      loi	1.15470
      muli.xyz		cwfot_tn,	cwfot_tn,	I

      mul.xyz		tn_dot_wind,	cwfot_wind,	cwfot_tn
      addy.x		tn_dot_wind,	tn_dot_wind,	tn_dot_wind
      addz.x		tn_dot_wind,	tn_dot_wind,	tn_dot_wind

      mul.x		cos_sqr,	tn_dot_wind,	tn_dot_wind
      loi		1.0
      addi.x		cwfot_one,	vf00,	I
      sub.x		sin_sqr,	cwfot_one,	cos_sqr
      sqrt		Q,		sin_sqr[x]

      addq.x		q_result,	vf00,	Q
      mulx.xyz		force_on_tri,	cwfot_tn,	q_result
      
      mulw.xyz		force_on_tri,	force_on_tri,	accum_wind
      mulw.xyz		force_on_tri,	force_on_tri,	cwfot_wind
      loi		1.65e-4
      muli.xyz		force_on_pt,	force_on_tri,	I

      add.xyz		cwfot_vt1_calc,	cwfot_vt1_calc,	force_on_pt
      add.xyz		cwfot_vt2_calc,	cwfot_vt2_calc,	force_on_pt
      add.xyz		cwfot_vt3_calc,	cwfot_vt3_calc,	force_on_pt


      ilw.x		vt1_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)   	
      ilw.y		vt2_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)
      ilw.z		vt3_ptr,	FLAG_TRIANGLE_DATA(cwfot_triangle_counter)
      
      sq		cwfot_vt1_calc,	FLAG_VERTS_CALCS(vt1_ptr)
      sq.xyz		cwfot_wind,	FLAG_VERTS_CALCS(vt1_ptr)		
      sq		cwfot_vt2_calc,	FLAG_VERTS_CALCS(vt2_ptr)
      sq		cwfot_vt3_calc,	FLAG_VERTS_CALCS(vt3_ptr)

      ibne		cwfot_triangle_counter,	vi00,	calc_wind_force_on_triangle_loop

break_cwfot_loop:
      jr		ret_calc_wind_force_on_triangle
      	

;**********************************************************************
;*                       FLAG VERTLET INTEGRATION		      *					
;**********************************************************************
do_vertlet_integration:
	iaddiu	dvi_vert_counter,	vi00,	NUM_FLAG_VERTS
	lq	gravity,			GRAVITY(vi00)
do_vertlet_loop:
	isubiu	dvi_vert_counter,	dvi_vert_counter,	1

	lq	dvi_current_vt,		FLAG_VERTS(dvi_vert_counter)
	lq	dvi_last_vt,		FLAG_VERTS_PREV(dvi_vert_counter)
	lq	dvi_forces,		FLAG_VERTS_CALCS(dvi_vert_counter)
	sq.xyz	dvi_current_vt,		FLAG_VERTS_PREV(dvi_vert_counter)

	add.xyz	dvi_forces,		vf00,	gravity
	loi	2.0
	muli.xyz	dvi_current_vt,	dvi_current_vt,I
	loi	1.0
	muli.xyz	dvi_last_vt,	dvi_last_vt,	I
	sub.xyz		dvi_new_vt,	dvi_current_vt,	dvi_last_vt
	loi	2.7777e-5
	muli.xyz	dvi_forces,	dvi_forces,	I	
	mulw.xyz	dvi_forces,	dvi_forces,	dvi_current_vt
	
;	sq.xyz		dvi_forces,		MAIN_O_BUFFER(dvi_vert_counter)
	
	add.xyz		dvi_new_vt,	dvi_forces, dvi_new_vt
	sq.xyz		dvi_new_vt,	FLAG_VERTS(dvi_vert_counter)
	ibne	dvi_vert_counter,	vi00,	do_vertlet_loop
	jr	ret_do_vertlet_integration

; ****************************************************************
;
;******************************************************************
do_vert_constraints:
	iaddiu	rs_i,	vi00,	8
dvc_loop_a:
	isubiu	rs_i,		rs_i,		1
	ilw.w	dvc_vt_i,	ROPE_STICKS(rs_i)
	ilw.z	cv_vt2_i,	ROPE_STICKS(rs_i)
	bal	ret_constrain_rope_vts,	constrain_rope_vts2
	ilw.y	dvc_vt_i,	ROPE_STICKS(rs_i)
	ilw.x	cv_vt2_i,	ROPE_STICKS(rs_i)
	bal	ret_constrain_rope_vts,	constrain_rope_vts2
	ibne	rs_i,		vi00,	dvc_loop_a
dvc_loop_b
	ilw.x	dvc_vt_i,	ROPE_STICKS(rs_i)
	ilw.y	cv_vt2_i,	ROPE_STICKS(rs_i)
	bal	ret_constrain_rope_vts,	constrain_rope_vts2
	ilw.z	dvc_vt_i,	ROPE_STICKS(rs_i)
	ilw.w	cv_vt2_i,	ROPE_STICKS(rs_i)
	bal	ret_constrain_rope_vts,	constrain_rope_vts2
	iaddiu	rs_i,		rs_i,	1
	iaddiu	max_loop,	vi00,	8
	ibne	max_loop,	rs_i,	dvc_loop_b

	b	ret_do_vert_constraints

constrain_rope_vts2:
     lq		dvc_vt1,	FLAG_VERTS(dvc_vt_i)
     lq		dvc_vt2,	FLAG_VERTS(cv_vt2_i)
     sub.xyz	dif,	dvc_vt1,	dvc_vt2
     
     loi	9.0e-1
     addi.x	length,	vf00,	I
     mul.xyz	dot,	dif,		dif
     addy.x	dot,	dot,		dot
     addz.x	dot,	dot,		dot
     sqrt	q,	dot[x]
   
     add.w	imass,	dvc_vt1,	dvc_vt2
     mulq.w	imass,	imass,	q
     subq.x	length,	length,	q
     loi	-1
     muli.x	length,	length,	I
     div	q,		length[x],	imass[w]

     mulq.w	imass_dif,	dvc_vt1,	q	
     mulw.xyz	delta1,		dif,		imass_dif
     mulq.w	imass_dif2,	dvc_vt2,	q
     mulw.xyz	delta2,		dif,		imass_dif
     add.xyz	dvc_vt2,	dvc_vt2,	delta2
     add.xyz	dvc_vt1,	dvc_vt1,	delta1
     sq.xyz	dvc_vt2,	FLAG_VERTS(cv_vt2_i)
     sq.xyz	dvc_vt1,	FLAG_VERTS(dvc_vt_i)

     jr		ret_constrain_rope_vts





exit:

--exit
--endexit
